unit HDSDBGrds;

//////////////////////////////////////////////////////////////////////////
//$Date: 2/04/00 - 13:38:53 $                                           //
//La unit dbgrids no posee una interfaz para la clase  THDSDBGridEditor//
//la cual es el InplaceEdit utilizado por la clase TCustomDBGrid. lo    //
//anterior dificulta la edicin del Grid.                               //
//                                                                      //
//                                                                      //
// Basado en TDataGrid 2.0                                              //
//            EC Software 1997-1999                                    //
//           http://www.ec-software.com                                 //
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//By Hades (Colombia)                                                   //
//virrato@yahoo.com                                                     //
//Freeware                                                              //
//////////////////////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, DB, Extctrls,DBCtrls, DBGrids, HDSFuncs, DBTables,
  ComCtrls, Buttons, Math, HDSDraw;


type
  THDSBackgroundStyle = (bgsNone, bgsAll, bgsCells, bgsBack);

  THDSCheckBoxStyle = (ccsNone, ccs2States, ccs3States);

  THDSColumnOption = (coCheckBox, coCheckBoxGlyph, coCalendarEditor,
                      coGraphicEditor, coGraphicOpen, coGraphicSave,
                      coGraphicPreview, coMemoEditor, coMemoOpen,
                      coMemoSave, coMemoEdit, coQuickCheck,
                      coUseAccellerator);

  THDSColumnOptions = set of THDSColumnOption;

  THDSEditStyle = (esSimple, esEllipsis, esPickList, esDataList,
                   esCalendar, esGraphic, esMemo);

  THDSTabFillStyle = (tfColor, tfGradient, tfTexture);

  THDSDBGrid = class;

  THDSColumns = class;

  THDSColumn = class;

  THDSColumnEvent = procedure(Column: THDSColumn) of object;

  THDSColumnGraphicEvent = procedure(Column: THDSColumn;
                                     DBImage: TDBImage) of object;

  THDSColumnMemoEvent = procedure(Column: THDSColumn;
                                  DBMemo: TDBMemo) of object;

  THDSColumnTitle = class(TColumnTitle)
  private
    FEllipseStyle: THDSEllipseStyle;
    FGlyph: TBitmap;
    FGlyphAlignment: TAlignment;
    FGlyphMargins: TMargins;

    function GetColumn: THDSColumn;
    procedure SetEllipseStyle(const Value: THDSEllipseStyle);
    procedure SetGlyph(const Value: TBitmap);
    procedure SetGlyphAlignment(const Value: TAlignment);

  protected
    procedure DoMarginsChanged(Sender: TObject);

  public
    constructor Create(Column: THDSColumn);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    property Column: THDSColumn read GetColumn;

  published
    property EllipseStyle: THDSEllipseStyle read FEllipseStyle
                           write SetEllipseStyle default ellEnd;
    property Glyph: TBitmap read FGlyph write SetGlyph;
    property GlyphAlignment: TAlignment read FGlyphAlignment
                             write SetGlyphAlignment default taRightJustify;
    property GlyphMargins: TMargins read FGlyphMargins write FGlyphMargins;
  end;

  THDSColumnCheckBox = class(TPersistent)
  private
    FColumn: THDSColumn;
    FCheckBoxStyle: THDSCheckBoxStyle;
    FCheckedGlyph: TBitmap;
    FGrayedGlyph: TBitmap;
    FUnCheckedGlyph: TBitmap;
    FGlyphAlignment: TAlignment;
    FGlyphMargins: TMargins;
    FCheckedValue: string;
    FUnCheckedValue: string;
    FGrayedValue: string;

    procedure SetCheckBoxStyle(const Value: THDSCheckBoxStyle);
    procedure SetCheckedGlyph(const Value: TBitmap);
    procedure SetGrayedGlyph(const Value: TBitmap);
    procedure SetUnCheckedGlyph(const Value: TBitmap);
    procedure SetGlyphAlignment(const Value: TAlignment);
    function GetCollection: THDSColumns;

  protected
    procedure DoMarginsChanged(Sender: TObject);

  public
    constructor Create(Column: THDSColumn);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;

  public
    property Collection: THDSColumns read GetCollection;

  published
    property CheckBoxStyle: THDSCheckBoxStyle read FCheckBoxStyle
                            write SetCheckBoxStyle default ccsNone;
    property CheckedGlyph: TBitmap read FCheckedGlyph write SetCheckedGlyph;
    property CheckedValue: string read FCheckedValue write FCheckedValue;
    property GrayedGlyph: TBitmap read FGrayedGlyph write SetGrayedGlyph;
    property GrayedValue: string read FGrayedValue write FGrayedValue;
    property UnCheckedGlyph: TBitmap read FUnCheckedGlyph
                                     write SetUnCheckedGlyph;
    property UnCheckedValue: string read FUnCheckedValue write FUnCheckedValue;
    property GlyphAlignment: TAlignment read FGlyphAlignment
                             write SetGlyphAlignment default taRightJustify;
    property GlyphMargins: TMargins read FGlyphMargins write FGlyphMargins;

  end;

  THDSColumn = class(TColumn)
  private
    FSelectedColor: TColor;
    FFocusedColor: TColor;
    FCharCase: TEditCharCase;
    FEllipseStyle: THDSEllipseStyle;
    FCheckBox: THDSColumnCheckBox;
    FOptions: THDSColumnOptions;
    FTransparent: boolean;
    
    function GetCollection: THDSColumns;
    procedure SetCollection(const Value: THDSColumns);
    procedure SetEllipseStyle(const Value: THDSEllipseStyle);
    procedure SetOptions(const Value: THDSColumnOptions);
    function GetTitle: THDSColumnTitle;
    procedure SetTitle(Value: THDSColumnTitle);
    procedure SetTransparent(const Value: boolean);
    procedure SetFocusedColor(const Value: TColor);
    procedure SetSelectedColor(const Value: TColor);

  protected
    function CreateTitle: TColumnTitle; override;
    function CreateCheckBox: THDSColumnCheckBox; dynamic;

  public
    constructor Create(AOwner: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    property Collection: THDSColumns read GetCollection
                                           write SetCollection;

  published
    property CharCase: TEditCharCase read FCharCase write FCharCase
                                     default ecNormal;
    property CheckBox: THDSColumnCheckBox  read FCheckBox write FCheckBox;
    property EllipseStyle: THDSEllipseStyle read FEllipseStyle
                           write SetEllipseStyle default ellEnd;
    property FocusedColor: TColor read FFocusedColor write SetFocusedColor
                           default clBtnText;
    property Options: THDSColumnOptions read FOptions write SetOptions;
    property SelectedColor: TColor read FSelectedColor write SetSelectedColor
                           default clHighlightText;
    property Title: THDSColumnTitle read GetTitle write SetTitle;
    property Transparent: boolean read FTransparent write SetTransparent
                                  default False;
  end;

  THDSColumns = class(TDBGridColumns)
  private
    function GetItem(Index: integer): THDSColumn;
    procedure SetItem(Index: integer; NewItem: THDSColumn);

  protected
    procedure DataHeightChanged;
    function HeightGlyph(AGlyph: TBitmap; AIndex: integer): integer;
    procedure TitleHeightChanged;

  public
    function Add: THDSColumn;
    procedure UpdateColumn(Index: integer);
    procedure UpdateTitles;
    procedure UpdateGlyph(Index: integer; Glyph: TBitmap; Margins: TMargins);
    procedure UpdateTitleGlyph(Index: integer);
    procedure UpdateTitleMargins;
    property Items[Index: integer]: THDSColumn read GetItem
                                               write SetItem; default;
  end;

  THDSTabDBGrid = class(THDSTab)
  private
    FGradient: THDSGradient;
    FTexture: THDSTexture;
    FFillStyle: THDSTabFillStyle;

    procedure SetFillStyle(const Value: THDSTabFillStyle);
    procedure DoGradientChange(Sender: TObject);
    procedure DoTextureChange(Sender: TObject);
    
  protected
    function CreateGradient: THDSGradient; dynamic;
    function CreateTexture: THDSTexture; dynamic;

  public
    constructor Create(AOwner: TControl); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;

  published
    property FillStyle: THDSTabFillStyle read FFillStyle write SetFillStyle
                                         default tfTexture;
    property Gradient: THDSGradient read FGradient write FGradient;
    property Texture: THDSTexture read FTexture write FTexture;
  end;

  THDSPopupListbox = class(TCustomListbox)
  private
    FSearchText: String;
    FSearchTickCount: Longint;

  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure KeyPress(var Key: Char); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;

  //No todos los controles funcionan correctamente como ventana emergente
  //para esto se diseo la clase THDSPopupWindow
  THDSPopupWindow = class(TForm)
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);

  private
    FControl: TWinControl;
    FOldAppDeactivate: TNotifyEvent;

  protected
    procedure AppDeactive(Sender: TObject); dynamic;
    procedure CreateParams(var Params: TCreateParams); override;

  public
    property Control: TWinControl read FControl write FControl;
  end;

  THDSPopupCalendar = class(THDSPopupWindow)
  private
    function GetControl: TMonthCalendar;

  public
    constructor Create(AOwner: TComponent); override;
    property Control: TMonthCalendar read GetControl;
  end;

  THDSPopupEditor = class(THDSPopupWindow)
  private
    FPanel: TPanel;
    FCancelButton: TSpeedButton;
    FOKButton: TSpeedButton;
    FCutButton: TSpeedButton;
    FCopyButton: TSpeedButton;
    FPasteButton: TSpeedButton;
    FUndoButton: TSpeedButton;
    FOpenButton: TSpeedButton;
    FSaveButton: TSpeedButton;
    function GetControl: TDBMemo;

  public
    constructor Create(AOwner: TComponent); override;
    property Control: TDBMemo read GetControl;
    property Panel: TPanel read FPanel;
    property CancelButton: TSpeedButton read FCancelButton;
    property OKButton: TSpeedButton read FOKButton;
    property CutButton: TSpeedButton read FCutButton;
    property CopyButton: TSpeedButton read FCopyButton;
    property PasteButton: TSpeedButton read FPasteButton;
    property UndoButton: TSpeedButton read FUndoButton;
    property OpenButton: TSpeedButton read FOpenButton;
    property SaveButton: TSpeedButton read FSaveButton;
  end;

  THDSPopupViewer = class(THDSPopupWindow)
  private
    FPanel: TPanel;
    FOKButton: TSpeedButton;
    FOpenButton: TSpeedButton;
    FPreviewButton: TSpeedButton;
    FSaveButton: TSpeedButton;
    function GetControl: TDBImage;

  public
    constructor Create(AOwner: TComponent); override;
    property Control: TDBImage read GetControl;
    property Panel: TPanel read FPanel;
    property OKButton: TSpeedButton read FOKButton;
    property OpenButton: TSpeedButton read FOpenButton;
    property PreviewButton: TSpeedButton read FPreviewButton;
    property SaveButton: TSpeedButton read FSaveButton;
  end;

  THDSDBGridEditor = class(TInplaceEdit)
  private
    FButton: TSpeedButton;
    FCheckBox: TCheckBox;
    FWinParent: TPanel;
    FButtonWidth: Integer;
    FDataList: TDBLookupListBox;
    FPickList: THDSPopupListbox;
    FPopupCalendar: THDSPopupCalendar;
    FPopupGraphic: THDSPopupViewer;
    FPopupMemo: THDSPopupEditor;
    FActiveList: TWinControl;
    FLookupSource: TDatasource;
    FEditStyle: THDSEditStyle;
    FListVisible: Boolean;
    FCheckBoxStyle: THDSCheckBoxStyle;
    FCheckBoxHeight: integer;
    FCheckBoxWidth: integer;
    FCheckedValue: string;
    FUnCheckedValue: string;
    FGrayedValue: string;

    procedure SetEditStyle(Value: THDSEditStyle);
    procedure CMCancelMode(var Message: TCMCancelMode); Message CM_CANCELMODE;
    procedure WMCancelMode(var Message: TMessage); Message WM_CANCELMODE;
    procedure WMKillFocus(var Message: TMessage); Message WM_KILLFOCUS;
    procedure WMPaint(var Message: TWMPaint); Message WM_PAINT;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure DoButtonClick(Sender: TObject);
    procedure DoCheckBoxClick(Sender: TObject);
    procedure DoPanelMouseDown(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);

  protected
    procedure CalendarDblClick(Sender: TObject);
    procedure CalendarKeyUp(Sender: TObject; var  Key: Word;
                            Shift: TShiftState);
    procedure GraphicDblClick(Sender: TObject);
    procedure GraphicKeyUp(Sender: TObject; var  Key: Word;
                            Shift: TShiftState);
    procedure GraphicOKClick(Sender: TObject);
    procedure GraphicOpenClick(Sender: TObject);
    procedure GraphicPreviewClick(Sender: TObject);
    procedure GraphicSaveClick(Sender: TObject);
    procedure ListMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MemoCancelClick(Sender: TObject);
    procedure MemoCopyClick(Sender: TObject);
    procedure MemoCutClick(Sender: TObject);
    procedure MemoDblClick(Sender: TObject);
    procedure MemoOKClick(Sender: TObject);
    procedure MemoPasteClick(Sender: TObject);
    procedure MemoUndoClick(Sender: TObject);
    procedure MemoOpenClick(Sender: TObject);
    procedure MemoSaveClick(Sender: TObject);
    procedure PreviewKeyUp(Sender: TObject; var  Key: Word;
                            Shift: TShiftState);
    procedure BoundsChanged; override;
    procedure ButtonClick; dynamic;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure CheckBoxClick; dynamic;
    procedure CloseUp(Accept: Boolean);
    function CreateDataList: TDBLookupListBox; dynamic;
    function CreatePickList: THDSPopupListbox; dynamic;
    function CreatePopupCalendar: THDSPopupCalendar; dynamic;
    function CreatePopupGraphic: THDSPopupViewer; dynamic;
    function CreatePopupMemo: THDSPopupEditor; dynamic;
    procedure DropDown;
    procedure DoDropDownKeys(var Key: Word; Shift: TShiftState);
    procedure GraphicPreview; dynamic;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure PaintWindow(DC: HDC); override;
    procedure UpdateContents; override;
    procedure UpdateCheckBox; dynamic;
    procedure WndProc(var Message: TMessage); override;

    property ActiveList: TWinControl read FActiveList write FActiveList;
    property CheckBoxHeight: integer read FCheckBoxHeight write FCheckBoxHeight;
    property CheckBoxWidth: integer read FCheckBoxWidth write FCheckBoxWidth;
    property CheckBoxStyle: THDSCheckBoxStyle read FCheckBoxStyle;
    property DataList: TDBLookupListBox read FDataList;
    property EditStyle: THDSEditStyle read FEditStyle write SetEditStyle;
    property PickList: THDSPopupListbox read FPickList;
   
  public
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;
  end;

  THDSDBGrid = class(TCustomDBGrid)
  private
    { Private declarations }
    FAutoSize: boolean;
    FBackgroundStyle: THDSBackgroundStyle;
    FBackgroundImage: TBitmap;
    FCheckBoxWidth: integer;
    FCheckBoxHeight: integer;
    FIsHighlighted: boolean;
    FDataRowsHeight: integer;
    FTitleHeight: integer;
    FOnButtonClick: THDSColumnEvent;
    FOnCalendarDblClick: THDSColumnEvent;
    FOnCheckBoxClick: THDSColumnEvent;
    FOnGraphicDblClick: THDSColumnEvent;
    FOnGraphicOpenClick: THDSColumnGraphicEvent;
    FOnGraphicSaveClick: THDSColumnGraphicEvent;
    FOnMemoDblClick: THDSColumnEvent;
    FOnMemoOpenClick: THDSColumnMemoEvent;
    FOnMemoSaveClick: THDSColumnMemoEvent;
    FTabGrid: THDSTabDBGrid;

    procedure SetAutoSize(const Value: boolean);
    procedure SetBackgroundStyle(const Value: THDSBackgroundStyle);
    procedure SetBackgroundImage(const Value: TBitmap);
    function GetColumns: THDSColumns;
    procedure SetColumns(const Value: THDSColumns);
    procedure SetDataRowsHeight(const Value: integer);
    procedure SetTitleHeight(const Value: integer);
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
    procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint(var Message: TWMNCPaint); message WM_NCPAINT;
    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure DoTabChange(Sender: TObject);

  protected
    { Protected declarations }
    procedure ButtonClick(Column: THDSColumn); dynamic;
    procedure CalendarDblClick(Column: THDSColumn); dynamic;
    procedure CheckBoxClick(Column: THDSColumn); dynamic;
    procedure GraphicDblClick(Column: THDSColumn); dynamic;
    procedure GraphicOpenClick(Column: THDSColumn; DBImage: TDBImage); dynamic;
    procedure GraphicSaveClick(Column: THDSColumn; DBImage: TDBImage); dynamic;
    procedure MemoDblClick(Column: THDSColumn); dynamic;
    procedure MemoOpenClick(Column: THDSColumn; DBMemo: TDBMemo); dynamic;
    procedure MemoSaveClick(Column: THDSColumn; DBMemo: TDBMemo); dynamic;
    function CanDrawBackground: boolean;
    function CreateColumns: TDBGridColumns; override;
    function CreateEditor: TInplaceEdit; override;
    procedure CreateParams(var Params: TCreateParams); override;
    function CreateTabGrid: THDSTabDBGrid; dynamic;
    procedure DrawBackground(ARect: TRect; AState: TGridDrawState); dynamic;
    procedure DrawCell(ACol, ARow: longint; ARect: TRect;
                       AState: TGridDrawState); override;
    procedure DrawCheckBox(ARect: TRect; AState: TCheckBoxState;
                           Column: THDSColumn); dynamic;
    procedure DoEnter; override;
    procedure DoExit; override;
    function FindAccellerator(CharCode: word): boolean;
    procedure GetCheckBoxSize; dynamic;
    function GetCheckBoxRect(ARect: TRect): TRect;
    function GetTabRect: TRect;
    procedure HideEditor;
    procedure InvalideTab;
    function IsReading: boolean;
    procedure Loaded; override;
    procedure NewMaxDataHeight(NewHeight: integer); dynamic;
    procedure NewMaxTitleHeight(NewHeight: integer); dynamic;
    procedure Paint; override;
    procedure RowHeightsChanged; override;
    procedure PaintTab(Highlight: boolean); dynamic;
    function TabHitTest(X, Y: integer): boolean;

    property CheckBoxWidth: integer read FCheckBoxWidth write FCheckBoxWidth;
    property CheckBoxHeight: integer read FCheckBoxHeight write FCheckBoxHeight;
    property IsHighlighted: boolean read FIsHighlighted write FIsHighlighted;

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Canvas;
    property SelectedRows;

  published
    property Align;
    property Anchors;
    property AutoSize read FAutoSize write SetAutoSize default True;
    property BiDiMode;
    property BackgroundStyle: THDSBackgroundStyle read FBackgroundStyle
                               write SetBackgroundStyle default bgsCells;
    property BackgroundImage: TBitmap read FBackgroundImage write SetBackgroundImage;
    property BorderStyle;
    property Color;
    property Columns: THDSColumns read GetColumns write SetColumns stored False; //StoreColumns;
    property Constraints;
    property Ctl3D;
    property DataSource;
    property DefaultDrawing;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FixedColor;
    property Font;
    property ImeMode;
    property ImeName;
    property DataRowsHeight: integer read FDataRowsHeight write SetDataRowsHeight
                                    default 0;
    property TitleHeight: integer read FTitleHeight write SetTitleHeight
                                  default 0;
    property Options;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabGrid: THDSTabDBGrid read FTabGrid write FTabGrid;
    property TabOrder;                                           
    property TabStop;
    property TitleFont;
    property Visible;
    property OnButtonClick: THDSColumnEvent read FOnButtonClick
                                            write FOnButtonClick;
    property OnCalendarDblClick: THDSColumnEvent read FOnCalendarDblClick
                                                 write FOnCalendarDblClick;
    property OnCellClick;
    property OnCheckBoxClick: THDSColumnEvent read FOnCheckBoxClick
                                              write FOnCheckBoxClick;
    property OnColEnter;
    property OnColExit;
    property OnColumnMoved;
    property OnDrawDataCell;  { obsolete }
    property OnDrawColumnCell;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGraphicDblClick: THDSColumnEvent read FOnGraphicDblClick
                                                write FOnGraphicDblClick;
    property OnGraphicOpenClick: THDSColumnGraphicEvent
                                 read FOnGraphicOpenClick
                                 write FOnGraphicOpenClick;
    property OnGraphicSaveClick: THDSColumnGraphicEvent
                                 read FOnGraphicSaveClick
                                 write FOnGraphicSaveClick;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMemoDblClick: THDSColumnEvent read FOnMemoDblClick
                                             write FOnMemoDblClick;
    property OnMemoOpenClick: THDSColumnMemoEvent read FOnMemoOpenClick
                                                  write FOnMemoOpenClick;
    property OnMemoSaveClick: THDSColumnMemoEvent read FOnMemoSaveClick
                                                  write FOnMemoSaveClick;
    property OnStartDock;
    property OnStartDrag;
    property OnTitleClick;
  end;

  THDSSortStyle = (cssNone, cssAscendent, cssDescendent);

  THDSColumnSort = class(TPersistent)
  private
    FColumn: THDSColumn;
    FSortStyle: THDSSortStyle;
    FSortAscGlyph: TBitmap;
    FSortDesGlyph: TBitmap;
    FSortNoneGlyph: TBitmap;
    function GetCollection: THDSColumns;
    procedure SetSortStyle(const Value: THDSSortStyle);
    procedure SetSortAscGlyph(const Value: TBitmap);
    procedure SetSortDesGlyph(const Value: TBitmap);
    procedure SetSortNoneGlyph(const Value: TBitmap);

  public
    constructor Create(Column: THDSColumn);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent);override;
    property Column: THDSColumn read FColumn;
    property Collection: THDSColumns read GetCollection;

  published
    property SortAscGlyph: TBitmap read FSortAscGlyph write SetSortAscGlyph;
    property SortDesGlyph: TBitmap read FSortDesGlyph write SetSortDesGlyph;
    property SortNoneGlyph: TBitmap read FSortNoneGlyph write SetSortNoneGlyph;
    property SortStyle: THDSSortStyle read FSortStyle write SetSortStyle;
  end;

  THDSSortColumn = class(THDSColumn)
  private
    FSort: THDSColumnSort;
    FSortable: boolean;

  protected
    function CreateSort: THDSColumnSort; dynamic;

  public
    constructor Create(AOwner: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;

  published
    property Sort: THDSColumnSort read FSort write FSort;
    property Sortable: boolean read FSortable write FSortable default False;
  end;

  THDSSortColumns = class(THDSColumns)
  private
    function GetItem(Index: integer): THDSSortColumn;
    procedure SetItem(Index: integer; NewItem: THDSSortColumn);

  public
    function Add: THDSSortColumn;
    property Items[Index: integer]: THDSSortColumn read GetItem
                                                   write SetItem; default;
  end;

  THDSSortColumnEvent = procedure (Column: THDSSortColumn) of object;

  THDSSortDBGrid = class(THDSDBGrid)
  private
    FLastColumn: THDSSortColumn;
    FOnSort: THDSSortColumnEvent;
    function GetColumns: THDSSortColumns;
    procedure SetColumns(Value: THDSSortColumns);

  public
    constructor Create(AOwner: TComponent); override;
    function GetSQLOrder(Column: THDSSortColumn): string;

  protected
    function CreateColumns: TDBGridColumns; override;
    procedure SortOrderChanged(Column: THDSSortColumn); dynamic;
    procedure TitleClick(Column: TColumn); override;

  published
    property Columns: THDSSortColumns read GetColumns write SetColumns;
    property OnSort: THDSSortColumnEvent read FOnSort write FOnSort;
  end;

procedure KillMessage(Wnd: HWnd; Msg: Integer);
procedure Register;

implementation

{$R *.DFM}
{$R *.RES}

procedure KillMessage(Wnd: HWnd; Msg: Integer);
// Delete the requested message from the queue, but throw back
// any WM_QUIT msgs that PeekMessage may also return
var
  M: TMsg;
begin
  M.Message:= 0;
  if PeekMessage(M, Wnd, Msg, Msg, pm_Remove) and (M.Message = WM_QUIT) then
    PostQuitMessage(M.wparam);
end;

procedure ToggleCheckBox(CheckBox: TCheckBox);
begin
  with CheckBox do
    case State of
      cbUnchecked:
        if AllowGrayed then State := cbGrayed else State := cbChecked;
      cbChecked: State := cbUnchecked;
      cbGrayed: State := cbChecked;
    end;
end;

//THDSPopupListbox
procedure THDSPopupListbox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  with Params do
  begin
    Style:= Style or WS_BORDER;
    ExStyle:= WS_EX_TOOLWINDOW or WS_EX_TOPMOST;
    AddBiDiModeExStyle(ExStyle);
    WindowClass.Style:= CS_SAVEBITS;
  end;
end;

procedure THDSPopupListbox.CreateWnd;
begin
  inherited CreateWnd;
  Windows.SetParent(Handle, 0);
  CallWindowProc(DefWndProc, Handle, WM_SETFOCUS, 0, 0);
end;

procedure THDSPopupListbox.Keypress(var Key: Char);
var
  TickCount: Integer;
begin
  case Key of
    #8, #27: FSearchText:= '';
    #32..#255:
      begin
        TickCount:= GetTickCount;

        if TickCount - FSearchTickCount > 2000 then
          FSearchText:= '';

        FSearchTickCount:= TickCount;

        if Length(FSearchText) < 32 then
          FSearchText:= FSearchText + Key;

        SendMessage(Handle, LB_SelectString, WORD(-1), Longint(PChar(FSearchText)));
        Key:= #0;
      end;
  end;
  inherited Keypress(Key);
end;

procedure THDSPopupListbox.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
  THDSDBGridEditor(Owner).CloseUp((X >= 0) and (Y >= 0) and
                                  (X < Width) and (Y < Height));
end;

//THDSPopupWindow
procedure THDSPopupWindow.AppDeactive(Sender: TObject);
begin
  Close;
end;

procedure THDSPopupWindow.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  with Params do
    Style:= Style and not WS_CAPTION;
end;

procedure THDSPopupWindow.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Application.OnDeactivate:= FOldAppDeactivate;
end;

procedure THDSPopupWindow.FormDeactivate(Sender: TObject);
begin
  Close;
end;

procedure THDSPopupWindow.FormShow(Sender: TObject);
begin
  if FControl <> nil then
    FControl.SetFocus;

  FOldAppDeactivate:= Application.OnDeactivate;
  Application.OnDeactivate:= AppDeactive;
end;

//THDSPopupCalendar
constructor THDSPopupCalendar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  inherited Control:= TMonthCalendar.Create(Self);

  with Control do
  begin
    Name:= 'Calendar';
    Parent:= Self;
    Left:= 0;
    Top:= 0;
    Width:= Width + 5;
  end;
end;

function THDSPopupCalendar.GetControl: TMonthCalendar;
begin
  Result:= TMonthCalendar(inherited Control);
end;

//THDSPopupEditor
constructor THDSPopupEditor.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPanel:= TPanel.Create(Self);

  with FPanel do
  begin
    Name:= 'Panel';
    Caption:= '';
    Parent:= Self;
    Left:= 0;
    Top:= 0;
    Height:= 20;
    Width:= 250;
    BevelOuter:= bvNone;
  end;

  FCancelButton:= TSpeedButton.Create(Self);
  FOKButton:= TSpeedButton.Create(Self);
  FCutButton:= TSpeedButton.Create(Self);
  FPasteButton:= TSpeedButton.Create(Self);
  FCopyButton:= TSpeedButton.Create(Self);
  FUndoButton:= TSpeedButton.Create(Self);
  FOpenButton:= TSpeedButton.Create(Self);
  FSaveButton:= TSpeedButton.Create(Self);
  inherited Control:= TDBMemo.Create(Self);

  with FOKButton do
  begin
    Name:= 'OKButton';
    Parent:= FPanel;
    SetBounds(137, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'OK');
  end;

  with FCancelButton do
  begin
    Name:= 'CancelButton';
    Parent:= FPanel;
    SetBounds(156, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'CANCEL');
  end;

  with FOpenButton do
  begin
    Name:= 'OpenButton';
    Parent:= FPanel;
    SetBounds(1, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'OPEN');
  end;

  with FSaveButton do
  begin
    Name:= 'SaveButton';
    Parent:= FPanel;
    SetBounds(20, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'SAVE');
  end;

  with FCutButton do
  begin
    Name:= 'CutButton';
    Parent:= FPanel;
    SetBounds(44, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'CUT');
  end;

  with FCopyButton do
  begin
    Name:= 'CopyButton';
    Parent:= FPanel;
    SetBounds(63, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'COPY');
  end;

  with FPasteButton do
  begin
    Name:= 'PasteButton';
    Parent:= FPanel;
    SetBounds(82, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'PASTE');
  end;

  with FUndoButton do
  begin
    Name:= 'UndoButton';
    Parent:= FPanel;
    SetBounds(101, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'UNDO');
  end;

  with Control do
  begin
    Name:= 'Memo';
    Parent:= Self;
    Left:= 0;
    Top:= 21;
    Height:= 200;
    Width:= 250;
  end;
end;

function THDSPopupEditor.GetControl: TDBMemo;
begin
  Result:= TDBMemo(inherited Control);
end;

//THDSPopupViewer
constructor THDSPopupViewer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPanel:= TPanel.Create(Self);

  with FPanel do
  begin
    Name:= 'Panel';
    Caption:= '';
    Parent:= Self;
    Left:= 0;
    Top:= 0;
    Height:= 20;
    Width:= 125;
    BevelOuter:= bvNone;
  end;

  FOKButton:= TSpeedButton.Create(Self);
  FOpenButton:= TSpeedButton.Create(Self);
  FPreviewButton:= TSpeedButton.Create(Self);
  FSaveButton:= TSpeedButton.Create(Self);
  inherited Control:= TDBImage.Create(Self);

  with FOKButton do
  begin
    Name:= 'OKButton';
    Parent:= FPanel;
    SetBounds(106, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'OK');
  end;

  with FOpenButton do
  begin
    Name:= 'OpenButton';
    Parent:= FPanel;
    SetBounds(1, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'OPEN');
  end;

  with FSaveButton do
  begin
    Name:= 'SaveButton';
    Parent:= FPanel;
    SetBounds(19, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'SAVE');
  end;

  with FPreviewButton do
  begin
    Name:= 'PreviewButton';
    Parent:= FPanel;
    SetBounds(43, 1, 18, 18);
    Flat:= True;
    Glyph.LoadFromResourceName(HInstance, 'PREVIEW');
  end;

  with Control do
  begin
    Name:= 'Image';
    Parent:= Self;
    Left:= 0;
    Top:= 21;
    Height:= 125;
    Width:= 125;
  end;
end;

function THDSPopupViewer.GetControl: TDBImage;
begin
  Result:= TDBImage(inherited Control);
end;

//THDSDBGridEditor--Tomado de DBGrid.pas
constructor  THDSDBGridEditor.Create(Owner: TComponent);
begin
  //Procedimiento modificado
  inherited Create(Owner);
  FLookupSource:= TDataSource.Create(Self);
  FButtonWidth:= 14;
  FEditStyle:= esSimple;
  FCheckBoxStyle:= ccsNone;
  FCheckBoxHeight:= 0;
  FCheckBoxWidth:= 0;
  FWinParent:= TPanel.Create(Self);
  FButton:= TSpeedButton.Create(Self);
  FCheckBox:= TCheckBox.Create(Self);

  with FWinParent do
  begin
    Name:= 'ButtonParent';
    BevelOuter:= bvNone;
    Caption:= '';
    Ctl3D:= False;
    Width:= 0;
    Height:= 18;
    Color:= Self.Color;
    Visible:= True;
    Parent:= Self;
    ControlStyle:= ControlStyle + [csReplicatable];
    OnMouseDown:= DoPanelMouseDown;
  end;

  with FButton do
  begin
    Name:= 'Button';
    Width:= 0;
    Height:= 18;
    Visible:= True;
    Parent:= FWinParent;
    OnClick:= DoButtonClick;
  end;

  with FCheckBox do
  begin
    Name:= 'CheckBox';
    Caption:= '';
    Width:= 0;
    Height:= 18;
    Parent:= FWinParent;
    OnClick:= DoCheckBoxClick;
  end;
end;

destructor THDSDBGridEditor.Destroy;
begin
  inherited Destroy;
end;

//Intercambio de propiedades
procedure THDSDBGridEditor.SetEditStyle(Value: THDSEditStyle);
begin
  if Value <> FEditStyle then
  begin
    FEditStyle:= Value;

    case Value of
      esPickList:
      begin
        if FPickList = nil then
          FPickList:= CreatePickList;

        FActiveList:= FPickList;
      end;

      esDataList:
      begin
        if FDataList = nil then
          FDatalist:= CreateDataList;

        FActiveList:= FDataList;
      end;

      esCalendar:
      begin
        if FPopupCalendar = nil then
          FPopupCalendar:= CreatePopupCalendar;

        FActiveList:= FPopupCalendar;
      end;

      esGraphic:
      begin
        if FPopupGraphic = nil then
          FPopupGraphic:= CreatePopupGraphic;

        FActiveList:= FPopupGraphic;
      end;

      esMemo:
      begin
        if FPopupMemo = nil then
          FPopupMemo:= CreatePopupMemo;

        FActiveList:= FPopupMemo;
      end;

      else  { cbsNone, cbsEllipsis, or read only field }
        FActiveList:= nil;
    end;

    if FEditStyle = esEllipsis then
      FButton.Glyph.LoadFromResourceName(HInstance, 'POINTS')
    else if FEditStyle <> esSimple then
      FButton.Glyph.LoadFromResourceName(HInstance, 'ARROW');

    with THDSDBGrid(Grid) do
      Self.ReadOnly:= Columns[SelectedIndex].ReadOnly;
  end;
end;

//Manejo de mensajes
procedure  THDSDBGridEditor.CMCancelMode(var Message: TCMCancelMode);
begin
  if (Message.Sender <> Self) and (Message.Sender <> FActiveList) and
     (Message.Sender <> FButton) then
    CloseUp(False);
end;

procedure THDSDBGridEditor.WMCancelMode(var Message: TMessage);
begin
  THDSDBGrid(Grid).HideEditor;
end;

procedure THDSDBGridEditor.WMKillFocus(var Message: TMessage);
begin
  if not SysLocale.FarEast then
    inherited
  else
  begin
    ImeName:= Screen.DefaultIme;
    ImeMode:= imDontCare;
    inherited;

    if HWND(Message.WParam) <> THDSDBGrid(Grid).Handle then
      ActivateKeyboardLayout(Screen.DefaultKbLayout, KLF_ACTIVATE);
  end;

  if FListVisible then
    CloseUp(False);
end;

procedure  THDSDBGridEditor.WMPaint(var Message: TWMPaint);
begin
  PaintHandler(Message);
end;

procedure THDSDBGridEditor.WMSize(var Message: TWMSize);
var
  OffSet: integer;
begin
  inherited;

  if NewStyleControls and Ctl3D then
    OffSet:= 3
  else
    OffSet:= 1;

  if FCheckBoxStyle <> ccsNone then
  begin
    FWinParent.SetBounds(Offset, Offset, Width - Offset, Height - Offset);
    FCheckBox.SetBounds(Offset, Offset, CheckBoxWidth + Offset,
                        Height - Offset);
  end
  else
  begin
    FCheckBox.SetBounds(0, 0, 0, 0);

    if FEditStyle <> esSimple then
      FWinParent.SetBounds(Width - FButtonWidth - Offset, Offset,
                           FButtonWidth, Height - Offset)
    else
      FWinParent.SetBounds(0, 0, 0, 0);
  end;

  if FEditStyle <> esSimple then
    FButton.SetBounds(FWinParent.Width - FButtonWidth - Offset, Offset,
                      FButtonWidth, Height - Offset)
  else
    FButton.SetBounds(0, 0, 0, 0);
end;

procedure THDSDBGridEditor.DoButtonClick(Sender: TObject);
begin
  if FListVisible then
    CloseUp(False)
  else if Assigned(FActiveList) then
    DropDown
  else if (FEditStyle = esEllipsis) then
    ButtonClick;
end;

procedure THDSDBGridEditor.DoCheckBoxClick(Sender: TObject);
begin
  if FListVisible then
    CloseUp(False)
  else
  begin
    if not ReadOnly then
      case FCheckBox.State of
        cbUnchecked: Text:= FUnCheckedValue;
        cbChecked: Text:=  FCheckedValue;
        else //cbGrayed
          Text:= FGrayedValue;
      end;

    UpdateCheckBox;
    SetFocus;
    //THDSDBGrid(Grid).HideEditor;
    CheckBoxClick;
  end;
end;

//Creacion de editores
function THDSDBGridEditor.CreateDataList: TDBLookupListBox;
begin
  Result:= TPopupDataList.Create(Self);

  with Result do
  begin
    Visible:= False;
    Parent:= Self;
    OnMouseUp:= ListMouseUp;
  end;
end;

function THDSDBGridEditor.CreatePickList: THDSPopupListbox;
begin
  Result:= THDSPopupListbox.Create(Self);

  with Result do
  begin
    Visible:= False;
    Parent:= Self;
    OnMouseUp:= ListMouseUp;
    IntegralHeight:= True;
    ItemHeight:= 11;
  end;
end;

function THDSDBGridEditor.CreatePopupCalendar: THDSPopupCalendar;
begin
  Result:= THDSPopupCalendar.Create(Self);

  with Result do
  begin
    Visible:= False;
    OnKeyDown:= CalendarKeyUp;
    Control.OnDblClick:= CalendarDblClick;
  end;
end;

function THDSDBGridEditor.CreatePopupGraphic: THDSPopupViewer;
begin
  Result:= THDSPopupViewer.Create(Self);

  with Result do
  begin
    Visible:= False;
    OnKeyDown:= GraphicKeyUp;
    ShowHint:= True;

    with Control do
    begin
      Stretch:= True;
      OnDblClick:= GraphicDblClick;
    end;

    OKButton.OnClick:= GraphicOKClick;
    OKButton.Hint:= 'OK';
    OpenButton.OnClick:= GraphicOpenClick;
    OpenButton.Hint:= 'Open';
    PreviewButton.OnClick:= GraphicPreviewClick;
    PreviewButton.Hint:= 'Preview';
    SaveButton.OnClick:= GraphicSaveClick;
    SaveButton.Hint:= 'Save';
  end;
end;

function THDSDBGridEditor.CreatePopupMemo: THDSPopupEditor;
begin
  Result:= THDSPopupEditor.Create(Self);

  with Result do
  begin
    Visible:= False;
    ShowHint:= True;
    OKButton.OnClick:= MemoOKClick;
    OKButton.Hint:= 'OK';
    CancelButton.OnClick:= MemoCancelClick;
    CancelButton.Hint:= 'Cancel';
    CutButton.OnClick:= MemoCutClick;
    CutButton.Hint:= 'Cut';
    CopyButton.OnClick:= MemoCopyClick;
    CopyButton.Hint:= 'Copy';
    PasteButton.OnClick:= MemoPasteClick;
    PasteButton.Hint:= 'Paste';
    UndoButton.OnClick:= MemoUndoClick;
    UndoButton.Hint:= 'Undo';
    OpenButton.OnClick:= MemoOpenClick;
    OpenButton.Hint:= 'Open';
    SaveButton.OnClick:= MemoSaveClick;
    SaveButton.Hint:= 'Save';
    Control.OnDblClick:= MemoDblClick;
  end;
end;

//Procedimientos
procedure THDSDBGridEditor.BoundsChanged;
begin
  inherited BoundsChanged;
end;

procedure THDSDBGridEditor.ButtonClick;
begin
  with THDSDBGrid(Grid) do
    ButtonClick(Columns[SelectedIndex]);
end;

procedure THDSDBGridEditor.CalendarDblClick(Sender: TObject);
begin
  CloseUp(True);
  
  with THDSDBGrid(Grid) do
    CalendarDblClick(Columns[SelectedIndex]);
end;

procedure THDSDBGridEditor.CalendarKeyUp(Sender: TObject; var  Key: Word;
                                         Shift: TShiftState);
begin
  case Key of
    VK_RETURN, VK_ESCAPE:
    begin
      CloseUp(Key = VK_RETURN);
      Key:= 0;
    end;
  end;
end;

procedure THDSDBGridEditor.CheckBoxClick;
begin
  with THDSDBGrid(Grid) do
    CheckBoxClick(Columns[SelectedIndex]);
end;

procedure  THDSDBGridEditor.CloseUp(Accept: Boolean);
var
  MasterField: TField;
  ListValue: Variant;
  AIndex: integer;

  procedure ExchangeData;
  begin
    AIndex:= FPickList.ItemIndex;

    with THDSDBGrid(Grid), Columns[SelectedIndex].Field do
      if (FCheckBoxStyle = ccs2States) and (AIndex < 2) then
      begin
        if MasterField = nil then
          MasterField:= DataSet.FieldByName(FieldName);

        DataSet.Edit;

        if AIndex = 0 then
          MasterField.Value:= FCheckedValue
        else
          MasterField.Value:= FUnCheckedValue;
      end
      else if (FCheckBoxStyle = ccs3States) and (AIndex < 3) then
      begin
        if MasterField = nil then
          MasterField:= DataSet.FieldByName(FieldName);

        DataSet.Edit;

        case AIndex of
          0: MasterField.Value:= FCheckedValue;
          1: MasterField.Value:= FUnCheckedValue;
          else
            MasterField.Value:= FGrayedValue;
        end;
      end;
  end;

begin
  //Procedimiento modificado
  if FListVisible then
  begin
    if GetCapture <> 0 then
      SendMessage(GetCapture, WM_CANCELMODE, 0, 0);

    if FActiveList = FDataList then
      ListValue:= FDataList.KeyValue
    else if (FActiveList = FPickList) and (FPickList.ItemIndex <> -1) then
      ListValue:= FPickList.Items[FPicklist.ItemIndex]
    else if FActiveList = FPopupCalendar then
      try
        ListValue:= FPopupCalendar.Control.Date;
      except
      end;

    SetWindowPos(FActiveList.Handle, 0, 0, 0, 0, 0, SWP_NOZORDER or
      SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_HIDEWINDOW);
    FListVisible:= False;

    if Assigned(FDataList) then
      FDataList.ListSource:= nil;

    if Assigned(FPopupGraphic) then
      with FPopupGraphic.Control do
      begin
        DataSource:= nil;
        DataField:= '';
      end;

    if Assigned(FPopupMemo) then
      with FPopupMemo.Control do
      begin
        DataSource:= nil;
        DataField:= '';
      end;

    FLookupSource.Dataset:= nil;

    if Accept then
    begin
      if FActiveList = FDataList then
        with THDSDBGrid(Grid), Columns[SelectedIndex].Field do
        begin
          MasterField:= DataSet.FieldByName(KeyFields);

          if MasterField.CanModify then
            if FCheckBoxStyle <> ccsNone then
              ExchangeData
            else
            begin
              DataSet.Edit;
              MasterField.Value:= ListValue;
            end;
          end
      else
        if (not VarIsNull(ListValue)) and EditCanModify then
          if FCheckBoxStyle <> ccsNone then
            ExchangeData
          else
            with THDSDBGrid(Grid), Columns[SelectedIndex].Field do
              Value:= ListValue;
    end;
  end;

  SetFocus;
  THDSDBGrid(Grid).HideEditor;
end;

procedure THDSDBGridEditor.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style:= Params.Style or WS_CLIPCHILDREN or ES_MULTILINE;
end;

procedure THDSDBGridEditor.CreateWnd;
begin
  inherited CreateWnd;
end;

procedure  THDSDBGridEditor.DropDown;
var
  P: TPoint;
  I, J, X, Y, AAHeight, AHeight, AWidth: integer;
  Column: THDSColumn;
  ParentForm: TCustomForm;
  ShowButtons: boolean;
begin
  if not FListVisible and Assigned(FActiveList) then
  begin
    FActiveList.Width:= Width;

    with THDSDBGrid(Grid) do
      Column:= Columns[SelectedIndex];

    if FActiveList = FDataList then
      with Column.Field do
      begin
        FDataList.Color:= Color;
        FDataList.Font:= Font;
        FDataList.RowCount:= Column.DropDownRows;
        FLookupSource.DataSet:= LookupDataSet;
        FDataList.KeyField:= LookupKeyFields;
        FDataList.ListField:= LookupResultField;
        FDataList.ListSource:= FLookupSource;
        FDataList.KeyValue:= DataSet.FieldByName(KeyFields).Value;
      end
    else if FActiveList = FPickList then
    begin
      FPickList.Color:= Color;
      FPickList.Font:= Font;
      FPickList.Items:= Column.Picklist;

      if FPickList.Items.Count >= Integer(Column.DropDownRows) then
        FPickList.Height:= Integer(Column.DropDownRows) * FPickList.ItemHeight + 4
      else
        FPickList.Height:= FPickList.Items.Count * FPickList.ItemHeight + 4;

      if Column.Field.IsNull then
        FPickList.ItemIndex:= -1
      else
        FPickList.ItemIndex:= FPickList.Items.IndexOf(Column.Field.Text);

      J:= FPickList.ClientWidth;

      for I:= 0 to FPickList.Items.Count - 1 do
      begin
        Y:= FPickList.Canvas.TextWidth(FPickList.Items[I]);

        if Y > J then
          J:= Y;
      end;

      FPickList.ClientWidth:= J;
    end
    else if FActiveList = FPopupCalendar then
    begin
      with TDateField(Column.Field) do
        if not IsNull then
          try
            FPopupCalendar.Control.Date:= Value;
                          // StrToDate(FormatDateTime(ShortDateFormat, Value));
          except
          end;
    end
    else if FActiveList = FPopupGraphic then
    begin
      with FPopupGraphic.Control do
      begin
        DataSource:= THDSDBGrid(Grid).DataSource;
        DataField:= Column.FieldName;
        AHeight:= 175;
        AAHeight:= 175;
        AWidth:= 175;

        if Picture.Width > AWidth then
          AHeight:= Floor(Picture.Height * (AWidth / Picture.Width));

        if Picture.Height > AHeight then
          AWidth:= Floor(Picture.Width * (AHeight / Picture.Height));

        if AHeight > AAHeight then
        begin
          AWidth:= Floor(AWidth * (AAHeight / AHeight));
          AHeight:= AAHeight;
        end;

        SetBounds(Left, Top, AWidth, AHeight);
        FPopupGraphic.Height:= Top + Height;
      end;

      with FPopupGraphic do
      begin
        OpenButton.Visible:= (not Self.ReadOnly) and
                             (coGraphicOpen in Column.Options);
        PreviewButton.Visible:= coGraphicPreview in Column.Options;
        SaveButton.Visible:= coGraphicSave in Column.Options;
      end;
    end
    else if FActiveList = FPopupMemo then
    begin
      with FPopupMemo.Control do
      begin
        DataSource:= THDSDBGrid(Grid).DataSource;
        DataField:= Column.FieldName;
        ReadOnly:= Self.ReadOnly;
        Font.Assign(Self.Font);
      end;

      with FPopupMemo do
      begin
        ShowButtons:= (not Self.ReadOnly) and (coMemoEdit in Column.Options);
        CutButton.Visible:= ShowButtons;
        PasteButton.Visible:= ShowButtons;
        UndoButton.Visible:= ShowButtons;
        CopyButton.Visible:= ShowButtons;
        OpenButton.Visible:= (not Self.ReadOnly) and
                             (coMemoOpen in Column.Options);
        SaveButton.Visible:= coMemoSave in Column.Options;
      end;
    end;

    P:= Parent.ClientToScreen(Point(Left, Top));
    Y:= P.Y + Height;
    X:= P.X;

    if Y + FActiveList.Height > Screen.Height then
      Y:= P.Y - FActiveList.Height;

    if X + FActiveList.Width > Screen.Width then
      X:= P.X - FActiveList.Width + Width;

    SetWindowPos(FActiveList.Handle, HWND_TOP, X, Y, 0, 0,
      SWP_NOSIZE or SWP_NOACTIVATE or SWP_SHOWWINDOW);
    FActiveList.Visible:= True;
    FListVisible:= True;

    if FActiveList is THDSPopupWindow then
    begin
      THDSPopupWindow(FActiveList).Control.SetFocus;
      ParentForm:= GetParentForm(Self);

      if ParentForm <> nil then
        FlashWindow(ParentForm.Handle, True);
    end
    else
      Windows.SetFocus(Handle);
  end;
end;

procedure THDSDBGridEditor.DoPanelMouseDown(Sender: TObject; Button: TMouseButton;
                                            Shift: TShiftState; X, Y: Integer);
begin
  with THDSDBGrid(Grid) do
   if (FCheckBoxStyle <> ccsNone) and (Button = mbLeft) and
      (not Columns[SelectedIndex].ReadOnly) and
      (coQuickCheck in Columns[SelectedIndex].Options) then
   begin
     ToggleCheckBox(FCheckBox);
     DoCheckBoxClick(FCheckBox);
   end;
end;

procedure  THDSDBGridEditor.DoDropDownKeys(var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_UP, VK_DOWN:
      if ssAlt in Shift then
      begin
        if FListVisible then
          CloseUp(True)
        else
          DropDown;

        Key:= 0;
      end;
    VK_RETURN, VK_ESCAPE:
      if FListVisible and not (ssAlt in Shift) then
      begin
        CloseUp(Key = VK_RETURN);
        Key:= 0;
      end;
  end;
end;

procedure THDSDBGridEditor.GraphicPreview;
var
  PreviewForm: TForm;
  Panel: TPanel;
  APicture: TPicture;
begin
  if Assigned(FPopupGraphic) then
  begin
    PreviewForm:= TForm.Create(Application);
    APicture:= TDBImage(FPopupGraphic.Control).Picture;

    with PreviewForm do
    try
      Name:= 'PreviewForm';
      Caption:= 'Hades'' preview';
      BorderStyle:= bsSizeToolWin;
      Position:= poScreenCenter;
      KeyPreview:= True;
      OnKeyUp:= PreviewKeyUp;
      Panel:= TPanel.Create(PreviewForm);

      with Panel do
      begin
        Name:= 'Panel';
        Caption:= '';
        Align:= alClient;
        BevelOuter:= bvNone;
        BorderStyle:= bsSingle;
        BorderWidth:= 5;
        Color:= clWindow;
        Parent:= PreviewForm;

        with TImage.Create(PreviewForm) do
        begin
          Name:= 'Image';
          Caption:= '';
          Align:= alClient;
          Stretch:= True;
          Picture.Assign(APicture);
          Parent:= Panel;
        end;
      end;

      if APicture.Width > 0 then
      begin
        ClientWidth:= APicture.Width + (ClientWidth - Panel.ClientWidth)+ 10;
        ClientHeight:= APicture.Height + (ClientHeight - Panel.ClientHeight) + 10;
      end;

      ShowModal;
    finally
      Free;
    end;
  end;
end;

procedure  THDSDBGridEditor.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (EditStyle = esEllipsis) and (Key = VK_RETURN) and (Shift = [ssCtrl]) then
  begin
    THDSDBGrid(Grid).EditButtonClick;
    KillMessage(Handle, WM_CHAR);
  end
  else
    inherited KeyDown(Key, Shift);
end;

procedure  THDSDBGridEditor.ListMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    CloseUp(PtInRect(FActiveList.ClientRect, Point(X, Y)));
end;

procedure THDSDBGridEditor.GraphicDblClick(Sender: TObject);
begin
  with THDSDBGrid(Grid) do
    GraphicDblClick(Columns[SelectedIndex]);
end;

procedure THDSDBGridEditor.GraphicOKClick(Sender: TObject);
begin
  CloseUp(False);
end;

procedure THDSDBGridEditor.GraphicOpenClick(Sender: TObject);
begin
  with THDSDBGrid(Grid) do
    GraphicOpenClick(Columns[SelectedIndex], Self.FPopupGraphic.Control);
end;

procedure THDSDBGridEditor.GraphicPreviewClick(Sender: TObject);
begin
  GraphicPreview;
end;

procedure THDSDBGridEditor.GraphicSaveClick(Sender: TObject);
begin
  with THDSDBGrid(Grid) do
    GraphicSaveClick(Columns[SelectedIndex], FPopupGraphic.Control);
end;

procedure THDSDBGridEditor.GraphicKeyUp(Sender: TObject; var  Key: Word;
                                        Shift: TShiftState);
begin
  case Key of
    VK_RETURN, VK_ESCAPE:
    begin
      CloseUp(False);
      Key:= 0;
    end;
  end;
end;

procedure THDSDBGridEditor.PreviewKeyUp(Sender: TObject; var  Key: Word;
                                        Shift: TShiftState);
begin
  case Key of
    VK_RETURN, VK_ESCAPE:
    begin
      TForm(Sender).Close;
      Key:= 0;
    end;
  end;
end;

procedure THDSDBGridEditor.MemoCancelClick(Sender: TObject);
begin
  CloseUp(False);
end;

procedure THDSDBGridEditor.MemoCopyClick(Sender: TObject);
begin
  FPopupMemo.Control.CopyToClipboard;
end;

procedure THDSDBGridEditor.MemoCutClick(Sender: TObject);
begin
  FPopupMemo.Control.CutToClipboard;
end;

procedure THDSDBGridEditor.MemoOKClick(Sender: TObject);
begin
  with FPopupMemo.Control do
    if (not ReadOnly) and Modified then
    begin
      Field.DataSet.Edit;
      Field.DataSet.Post;
    end;

  CloseUp(False);
end;

procedure THDSDBGridEditor.MemoDblClick(Sender: TObject);
begin
  with THDSDBGrid(Grid) do
    MemoDblClick(Columns[SelectedIndex]);
end;

procedure THDSDBGridEditor.MemoOpenClick(Sender: TObject);
begin
  with THDSDBGrid(Grid) do
    MemoOpenClick(Columns[SelectedIndex], FPopupMemo.Control);
end;

procedure THDSDBGridEditor.MemoPasteClick(Sender: TObject);
begin
  FPopupMemo.Control.PasteFromClipboard;
end;

procedure THDSDBGridEditor.MemoSaveClick(Sender: TObject);
begin
  with THDSDBGrid(Grid) do
    MemoSaveClick(Columns[SelectedIndex], FPopupMemo.Control);
end;

procedure THDSDBGridEditor.MemoUndoClick(Sender: TObject);
begin
  FPopupMemo.Control.Undo;
end;

procedure THDSDBGridEditor.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseMove(Shift, X, Y);
end;

procedure  THDSDBGridEditor.PaintWindow(DC: HDC);
begin
  inherited PaintWindow(DC);
end;

procedure THDSDBGridEditor.UpdateCheckBox;
var
  MasterField: TField;
begin
  if not ReadOnly then
    with THDSDBGrid(Grid), Columns[SelectedIndex].Field do
    begin
      MasterField:= DataSet.FieldByName(FieldName);

      if MasterField.CanModify then
      begin
        DataSet.Edit;
        MasterField.Value:= Self.Text;
      end;
    end;
end;

procedure  THDSDBGridEditor.UpdateContents;
var
  Column: THDSColumn;
  NewStyle: THDSEditStyle;
  MasterField: TField;
begin
  //Procedimiento modificado
  with THDSDBGrid(Grid) do
    Column:= Columns[SelectedIndex];

  NewStyle:= esSimple;
  FCheckBoxStyle:= Column.CheckBox.CheckBoxStyle;
  Color:= Column.Color;
  Font.Assign(Column.Font);

  case Column.ButtonStyle of
    cbsEllipsis: NewStyle:= esEllipsis;

    cbsAuto:
      if Assigned(Column.Field) then
        with Column.Field do
        begin
          if FieldKind = fkLookup then
          begin
            MasterField:= Dataset.FieldByName(KeyFields);

            if Assigned(MasterField) and MasterField.CanModify and not
               ((cvReadOnly in Column.AssignedValues) and Column.ReadOnly) then
              with THDSDBGrid(Grid) do
                if not ReadOnly and DataLink.Active and not Datalink.ReadOnly then
                  NewStyle:= esDataList;
          end
          else if  Assigned(Column.Picklist) and
                   (Column.PickList.Count > 0) and  not Column.Readonly then
            NewStyle:= esPickList
          else if DataType in [ftDataset, ftReference] then
            NewStyle:= esEllipsis
          else if (coCalendarEditor in Column.Options) and
                  (FCheckBoxStyle = ccsNone) and
                  ((DataType = ftDateTime) or (DataType = ftDate)) then
            NewStyle:= esCalendar
          else if (coGraphicEditor in Column.Options) and (DataType = ftGraphic) and
                  (FCheckBoxStyle = ccsNone) then
            NewStyle:= esGraphic
          else if (coMemoEditor in Column.Options) and (DataType = ftMemo) and
                  (FCheckBoxStyle = ccsNone) then
            NewStyle:= esMemo;
       end;
  end;

  if FCheckBoxStyle <> ccsNone then
    with Column.CheckBox do
    begin
      Self.FCheckedValue:= CheckedValue;
      Self.FUnCheckedValue:= UnCheckedValue;
      Self.FGrayedValue:= GrayedValue;
    end;

  ReadOnly:= Column.ReadOnly;
  Font.Assign(Column.Font);
  CharCase:= Column.CharCase;
  SetEditStyle(NewStyle);
  inherited UpdateContents;

  if FCheckBoxStyle <> ccsNone then
  begin
    if Text = FCheckedValue then
      FCheckBox.State:= cbChecked
    else if Text = FUnCheckedValue then
      FCheckBox.State:= cbUnchecked
    else
      FCheckBox.State:= cbGrayed;

    FCheckBox.AllowGrayed:= FCheckBoxStyle = ccs3States;
  end;

  if FEditStyle = esMemo then
  begin
    FPopupMemo.Control.Color:= Column.Color;
    FPopupMemo.Control.Font.Assign(Column.Font);
  end;
end;

procedure  THDSDBGridEditor.WndProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_KEYDOWN, WM_SYSKEYDOWN, WM_CHAR:
      if EditStyle in [esPickList, esDataList] then
        with TWMKey(Message) do
        begin
          DoDropDownKeys(CharCode, KeyDataToShiftState(KeyData));

          if (CharCode <> 0) and FListVisible then
          begin
            with TMessage(Message) do
              SendMessage(FActiveList.Handle, Msg, WParam, LParam);

            Exit;
          end;
        end;
  end;

  inherited WndProc(Message);
end;
//Fin del codigo modificado

//THDSCommomColumnTitle
constructor THDSColumnTitle.Create(Column: THDSColumn);
begin
  inherited Create(Column);
  FGlyph:= TBitmap.Create;
  FGlyphAlignment:= taRightJustify;
  FGlyphMargins:= TMargins.Create(Column.Grid);
  FGlyphMargins.OnChange:= DoMarginsChanged;
end;

destructor THDSColumnTitle.Destroy;
begin
  FGlyph.Free;
  FGlyphMargins.Free;
  inherited Destroy;
end;

//Intercambio de propiedades
procedure THDSColumnTitle.SetEllipseStyle(const Value: THDSEllipseStyle);
begin
  if FEllipseStyle <> Value then
  begin
    FEllipseStyle:= Value;

    with Column do
      Collection.UpdateColumn(Index);
  end;
end;

function THDSColumnTitle.GetColumn: THDSColumn;
begin
  Result:= THDSColumn(inherited Column);
end;

procedure THDSColumnTitle.SetGlyph(const Value: TBitmap);
begin
  if Assigned(FGlyph) then
  begin
    FGlyph.Assign(Value);

    with Column do
      Collection.UpdateTitleGlyph(Index);
  end;
end;

procedure THDSColumnTitle.SetGlyphAlignment(const Value: TAlignment);
begin
  if FGlyphAlignment <> Value then
  begin
    FGlyphAlignment:= Value;

    with Column do
      Collection.UpdateColumn(Index);
  end;
end;

//procedimientos
procedure THDSColumnTitle.Assign(Source: TPersistent);
begin
  if Source is THDSColumnTitle then
    with THDSColumnTitle(Source) do
    begin
      Self.FEllipseStyle:= FEllipseStyle;
      Self.FGlyph.Assign(FGlyph);
      Self.FGlyphMargins.Assign(FGlyphMargins);
    end;

  inherited Assign(Source);
end;

procedure THDSColumnTitle.DoMarginsChanged(Sender: TObject);
begin
  with Column do
    Collection.UpdateTitleMargins;
end;

//THDSColumnCheckBox
constructor THDSColumnCheckBox.Create(Column: THDSColumn);
begin
  inherited Create;
  FColumn:= Column;
  FCheckedValue:= 'T';
  FUnCheckedValue:= 'F';
  FGrayedValue:= 'U';
  FCheckBoxStyle:= ccsNone;
  FCheckedGlyph:= TBitmap.Create;
  FGrayedGlyph:= TBitmap.Create;
  FUnCheckedGlyph:= TBitmap.Create;
  FGlyphAlignment:= taRightJustify;
  FGlyphMargins:= TMargins.Create(FColumn.Grid);
  FGlyphMargins.OnChange:= DoMarginsChanged;
end;

destructor THDSColumnCheckBox.Destroy;
begin
  FCheckedGlyph.Free;
  FCheckedGlyph:= nil;
  FGrayedGlyph.Free;
  FGrayedGlyph:= nil;
  FUnCheckedGlyph.Free;
  FUnCheckedGlyph:= nil;
  FGlyphMargins.Free;
  FGlyphMargins:= nil;
  inherited Destroy;
end;

//Intercambio de propiedades
procedure THDSColumnCheckBox.SetCheckBoxStyle(const Value: THDSCheckBoxStyle);
begin
  if FCheckBoxStyle <> Value then
  begin
    FCheckBoxStyle:= Value;
    Collection.UpdateColumn(FColumn.Index);
  end;
end;

procedure THDSColumnCheckBox.SetCheckedGlyph(const Value: TBitmap);
begin
  if Assigned(FCheckedGlyph) then
  begin
    FCheckedGlyph.Assign(Value);
    Collection.UpdateGlyph(FColumn.Index, FCheckedGlyph, FGlyphMargins);
  end;
end;

procedure THDSColumnCheckBox.SetGrayedGlyph(const Value: TBitmap);
begin
  if Assigned(FGrayedGlyph) then
  begin
    FGrayedGlyph.Assign(Value);
    Collection.UpdateGlyph(FColumn.Index, FGrayedGlyph, FGlyphMargins);
  end;
end;

procedure THDSColumnCheckBox.SetUnCheckedGlyph(const Value: TBitmap);
begin
  if Assigned(FUnCheckedGlyph) then
  begin
    FUnCheckedGlyph.Assign(Value);
    Collection.UpdateGlyph(FColumn.Index, FUnCheckedGlyph, FGlyphMargins);
  end;
end;

procedure THDSColumnCheckBox.SetGlyphAlignment(const Value: TAlignment);
begin
  if FGlyphAlignment <> Value then
  begin
    FGlyphAlignment:= Value;
    Collection.UpdateColumn(FColumn.Index);
  end;
end;

function THDSColumnCheckBox.GetCollection: THDSColumns;
begin
  Result:= FColumn.Collection;
end;

//Procedimientos
procedure THDSColumnCheckBox.Assign(Source: TPersistent);
begin
  if Source is THDSColumnCheckBox then
    with THDSColumnCheckBox(Source) do
    begin
      Self.FCheckBoxStyle:= FCheckBoxStyle;
      Self.FCheckedGlyph.Assign(FCheckedGlyph);
      Self.FGrayedGlyph.Assign(FGrayedGlyph);
      Self.FUnCheckedGlyph.Assign(FUnCheckedGlyph);
      Self.FGlyphMargins.Assign(FGlyphMargins);
    end
  else
    inherited Assign(Source);
end;

procedure THDSColumnCheckBox.DoMarginsChanged(Sender: TObject);
begin
  Collection.UpdateColumn(FColumn.Index);
end;

//THDSColumn
constructor THDSColumn.Create(AOwner: TCollection);
begin
  inherited Create(AOwner);
  FCharCase:= ecNormal;
  FCheckBox:= CreateCheckBox;
  FTransparent:= False;
  FOptions:= [coCheckBox, coCheckBoxGlyph, coCalendarEditor, coGraphicEditor,
              coGraphicPreview, coMemoEditor, coMemoEdit, coUseAccellerator];
  FSelectedColor:= clHighlightText;
  FFocusedColor:= clBtnText;
end;

destructor THDSColumn.Destroy;
begin
  FCheckBox.Free;
  FCheckBox:= nil;
  inherited Destroy;
end;

//Intercambio de propiedades
function THDSColumn.GetCollection: THDSColumns;
begin
  Result:= THDSColumns(inherited Collection);
end;

procedure THDSColumn.SetCollection(const Value: THDSColumns);
begin
  inherited Collection:= Value;
end;

procedure THDSColumn.SetEllipseStyle(const Value: THDSEllipseStyle);
begin
  if FEllipseStyle <> Value then
  begin
    FEllipseStyle:= Value;
    Collection.UpdateColumn(Index);
  end;
end;

procedure THDSColumn.SetOptions(const Value: THDSColumnOptions);
begin
  if FOptions <> Value then
  begin
    FOptions:= Value;
    Collection.UpdateColumn(Index);
  end;
end;

function THDSColumn.GetTitle: THDSColumnTitle;
begin
  Result:= THDSColumnTitle(inherited Title);
end;

procedure THDSColumn.SetTitle(Value: THDSColumnTitle);
begin
  inherited Title:= Value;
end;

procedure THDSColumn.SetTransparent(const Value: boolean);
begin
  if FTransparent <> Value then
  begin
    FTransparent:= Value;
    Collection.UpdateColumn(Index);
  end;
end;

procedure THDSColumn.SetFocusedColor(const Value: TColor);
begin
  if FFocusedColor <> Value then
  begin
    FFocusedColor:= Value;
    Collection.UpdateColumn(Index);
  end;
end;

procedure THDSColumn.SetSelectedColor(const Value: TColor);
begin
  if FSelectedColor <> Value then
  begin
    FSelectedColor:= Value;
    Collection.UpdateColumn(Index);
  end;
end;

//Procedimentos
procedure THDSColumn.Assign(Source: TPersistent);
begin
  if Source is THDSColumn then
    with THDSColumn(Source) do
    begin
      Self.FEllipseStyle:= FEllipseStyle;
      Self.FCheckBox.Assign(FCheckBox);
      Self.FOptions:= FOptions;
    end;

  inherited Assign(Source);
end;

function THDSColumn.CreateTitle: TColumnTitle;
begin
  Result:= THDSColumnTitle.Create(Self);
end;

function THDSColumn.CreateCheckBox: THDSColumnCheckBox;
begin
  Result:= THDSColumnCheckBox.Create(Self);
end;

//THDSColumns
//Intercambio de propiedades
function THDSColumns.GetItem(Index: integer): THDSColumn;
begin
  Result:= THDSColumn(inherited GetItem(Index));
end;

procedure THDSColumns.SetItem(Index: integer; NewItem: THDSColumn);
begin
  inherited SetItem(Index, NewItem);
end;

//Proceedimientos
function THDSColumns.Add: THDSColumn;
begin
  Result:= THDSColumn(inherited Add);
end;

procedure THDSColumns.DataHeightChanged;
var
  i, AHeight, CheckedHeight, GrayedHeight, UncheckedHeight, MaxHeight: integer;
begin
  MaxHeight:= 0;

  for i:= 0 to Count - 1 do
    with Items[i].CheckBox do
    begin
      CheckedHeight:= HeightGlyph(CheckedGlyph, i);
      GrayedHeight:= HeightGlyph(GrayedGlyph, i);
      UncheckedHeight:= HeightGlyph(UncheckedGlyph, i);
      AHeight:= MaxIntValue([CheckedHeight, GrayedHeight, UncheckedHeight]);

      if AHeight > MaxHeight then
        MaxHeight:= AHeight;
    end;

  with THDSDBGrid(Grid) do
    if MaxHeight > DataRowsHeight then
      NewMaxDataHeight(MaxHeight);
end;

function THDSColumns.HeightGlyph(AGlyph: TBitmap; AIndex: integer): integer;
begin
  Result:= 0;

  if (AGlyph <> nil) and (AGlyph.Height > 0) then
    with Items[AIndex] do
      Result:= AGlyph.Height + CheckBox.GlyphMargins.Top +
                                 CheckBox.GlyphMargins.Bottom + 2;
end;

procedure THDSColumns.TitleHeightChanged;
var
  i, AHeight, MaxHeight: integer;
begin
  MaxHeight:= 0;

  for i:= 0 to Count - 1 do
    with Items[i].Title do
      if (Glyph <> nil) then
      begin
        if Glyph.Height <= 0 then
          AHeight:= 0
        else
          AHeight:= Glyph.Height + GlyphMargins.Top + GlyphMargins.Bottom + 4;

        if AHeight > MaxHeight then
          MaxHeight:= AHeight;
      end;

  with THDSDBGrid(Grid) do
    if MaxHeight >  TitleHeight then
      NewMaxTitleHeight(MaxHeight);
end;

procedure THDSColumns.UpdateColumn(Index: integer);
begin
  with THDSDBGrid(Grid) do
  begin
    InvalidateCol(DataToRawColumn(Index));
    RowHeightsChanged;
  end;
end;

procedure THDSColumns.UpdateTitles;
begin
  with THDSDBGrid(Grid) do
  begin
    InvalidateTitles;
    RowHeightsChanged;
  end;  
end;

procedure THDSColumns.UpdateGlyph(Index: integer; Glyph: TBitmap;
                                  Margins: TMargins);
begin
  DataHeightChanged;
  UpdateColumn(Index);
end;

procedure THDSColumns.UpdateTitleGlyph(Index: integer);
begin
  TitleHeightChanged;
  UpdateColumn(Index);
end;

procedure THDSColumns.UpdateTitleMargins;
begin
  UpdateTitles;
end;

//THDSTabDBGrid
constructor THDSTabDBGrid.Create(AOwner: TControl);
begin
  inherited Create(AOwner);
  FGradient:= CreateGradient;
  FGradient.OnGradientChange:= DoGradientChange;
  FTexture:= CreateTexture;
  FTexture.OnTextureChange:= DoTextureChange;
  FFillStyle:= tfTexture;
end;

destructor THDSTabDBGrid.Destroy;
begin
  FGradient.Free;
  FGradient:= nil;
  FTexture.Free;
  FTexture:= nil;
  inherited Destroy;
end;

//Intercambio de propiedades
procedure THDSTabDBGrid.SetFillStyle(const Value: THDSTabFillStyle);
begin
  if FFillStyle <> Value then
  begin
    FFillStyle:= Value;
    DoTabChange;
  end;
end;

//Procedimientos
procedure THDSTabDBGrid.Assign(Source: TPersistent);
begin
  if Source is THDSTabDBGrid then
    with THDSTabDBGrid(Source) do
    begin
      Self.FGradient.Assign(FGradient);
      Self.FTexture.Assign(FTexture);
    end;

  inherited Assign(Source);
end;

procedure THDSTabDBGrid.DoGradientChange(Sender: TObject);
begin
  if Assigned(OnTabChange) then
    OnTabChange(Self);
end;

procedure THDSTabDBGrid.DoTextureChange(Sender: TObject);
begin
  if Assigned(OnTabChange) then
    OnTabChange(Self);
end;

function THDSTabDBGrid.CreateGradient: THDSGradient;
begin
  Result:= THDSGradient.Create(Owner);
end;

function THDSTabDBGrid.CreateTexture: THDSTexture;
begin
  Result:= THDSTexture.Create(Owner);
end;

//THDSDBGrid
constructor THDSDBGrid.Create(AOwner: TComponent);
begin
  GetCheckBoxSize; //Modifica FCheckBoxHeigth, FCheckBoxWidth;
  FAutoSize:= True;
  inherited Create(AOwner); //Esto debe ir aqui
  FDataRowsHeight:=  DefaultRowHeight;
  FTitleHeight:= RowHeights[0];
  FTabGrid:= CreateTabGrid;
  FTabGrid.OnTabChange:= DoTabChange;
  FBackgroundImage:= TBitmap.Create;
  FBackgroundStyle:= bgsCells;
end;

destructor THDSDBGrid.Destroy;
begin
  FBackgroundImage.Free;
  FBackgroundImage:= nil;
  FTabGrid.Free;
  FTabGrid:= nil;
  inherited Destroy;
end;

//Intercambio de propiedades
procedure THDSDBGrid.SetAutoSize(const Value: boolean);
begin
  if FAutoSize <> Value then
  begin
    FAutoSize:= Value;

    if FAutoSize then
    begin
      BeginLayout;
      EndLayout;
    end;
  end;
end;

procedure THDSDBGrid.SetBackgroundStyle(const Value: THDSBackgroundStyle);
begin
  if FBackgroundStyle <> Value then
  begin
    FBackgroundStyle:= Value;
    Invalidate;
  end;
end;

procedure THDSDBGrid.SetBackgroundImage(const Value: TBitmap);
begin
  if FBackgroundImage <> nil then
  begin
    FBackgroundImage.Assign(Value);
    Invalidate;
  end;
end;

function THDSDBGrid.GetColumns: THDSColumns;
begin
  Result:= THDSColumns(inherited Columns);
end;

procedure THDSDBGrid.SetColumns(const Value: THDSColumns);
begin
  inherited Columns:= Value;
end;

procedure THDSDBGrid.SetDataRowsHeight(const Value: integer);
begin
  if FDataRowsHeight <> Value then
  begin
    FDataRowsHeight:= Value;
    RowHeightsChanged;
  end;
end;

procedure THDSDBGrid.SetTitleHeight(const Value: integer);
begin
  if FTitleHeight <> Value then
  begin
    FTitleHeight:= Value;
    RowHeightsChanged;
  end;
end;

//Manejo de mensajes
procedure THDSDBGrid.CMDialogChar(var Message: TCMDialogChar);
begin
  with Message do
    if FindAccellerator(CharCode) then
      Result:= 1;
end;

procedure THDSDBGrid.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;

  with FTabGrid do
    if Visible then
      Inc(Message.CalcSize_Params^.Rgrc[0].Top, Size);
end;

procedure THDSDBGrid.WMNCHitTest(var Message: TWMNCHitTest);
begin
  inherited;
  
  if TabHitTest(Message.XPos, Message.YPos) then
    Message.Result:= HTCLIENT; 
end;

procedure THDSDBGrid.WMNCPaint(var Message: TWMNCPaint);
begin
  inherited;
  PaintTab(FIsHighlighted);
end;

procedure THDSDBGrid.WMSize(var Message: TWMSize);
begin
  inherited;
  PaintTab(FIsHighlighted);
end;

//Procedimientos
procedure THDSDBGrid.DoTabChange(Sender: TObject);
begin
  if not IsReading then
    InvalideTab;
end;

function  THDSDBGrid.CreateColumns: TDBGridColumns;
begin
  Result:= THDSColumns.Create(Self, THDSColumn);
end;

function THDSDBGrid.CreateEditor: TInplaceEdit;
begin
  Result:= THDSDBGridEditor.Create(Self); //TInplaceEdit(THDSInplaceEdit.Create(Self));
  THDSDBGridEditor(Result).CheckBoxHeight:= FCheckBoxHeight;
  THDSDBGridEditor(Result).CheckBoxWidth:= FCheckBoxWidth;
end;

function THDSDBGrid.CreateTabGrid: THDSTabDBGrid;
begin
  Result:= THDSTabDBGrid.Create(Self);
end;

procedure THDSDBGrid.DoEnter;
begin
  inherited DoEnter;
  FIsHighlighted:= True;
  PaintTab(FIsHighlighted);
end;

procedure THDSDBGrid.DoExit;
begin
  inherited DoExit;
  FIsHighlighted:= False;
  PaintTab(FIsHighlighted);
end;

procedure THDSDBGrid.Loaded;
begin
  inherited Loaded;
  RowHeightsChanged;
end;

//Procedimientos de dibujo
function THDSDBGrid.CanDrawBackground: boolean;
begin
  Result:= DefaultDrawing and Assigned(FBackgroundImage) and
          (FBackgroundImage.Width > 0) and (FBackgroundImage.Height > 0);
end;

procedure THDSDBGrid.DrawBackground(ARect: TRect; AState: TGridDrawState);
var
  RMode: TCopyMode;
  SRect, DRect, IRect: TRect;
  XCnt, YCnt, X, Y: Integer;
begin
  //Desde DataGrid.Pas
  if (FBackgroundImage.Width > 0) and (FBackgroundImage.Height > 0) then
  begin
    RMode:= Canvas.CopyMode;

    if (gdSelected in AState) then
      Canvas.CopyMode:= cmNotSrcCopy;

    XCnt:= (Clientwidth) div FBackgroundImage.Width;
    YCnt:= (Clientheight) div FBackgroundImage.Height;

    for X:= 0 to XCnt do
    begin
      for Y:= 0 to YCnt do
      begin
        DRect.Left:= X * FBackgroundImage.Width;
        DRect.Top:= Y * FBackgroundImage.Height;
        DRect.Right:= DRect.Left + FBackgroundImage.Width;
        DRect.Bottom:= DRect.Top + FBackgroundImage.Height;

        if IntersectRect(IRect, ARect, DRect) then
        begin
          SRect:= IRect;

          while SRect.Left >= FBackgroundImage.Width  do
            OffsetRect(SRect, -FBackgroundImage.Width, 0);

          while SRect.Top >= FBackgroundImage.Height do
            OffsetRect(SRect, 0, -FBackgroundImage.Height);

          Canvas.CopyRect(IRect, FBackgroundImage.Canvas, SRect);
        end;
      end;
    end;

    Canvas.CopyMode:= RMode;
  end;
end;

procedure THDSDBGrid.DrawCell(ACol, ARow: longint; ARect: TRect;
                              AState: TGridDrawState);
var
  AARow, AACol: longint;
  Column: THDSColumn;
  Value: string;
  FixedState, HasBackground: boolean;

  function CanDrawFocus: boolean;
  begin
    Result:= DefaultDrawing and (gdSelected in AState)
             and ((dgAlwaysShowSelection in Options) or Focused)
             and not (csDesigning in ComponentState)
             and not (dgRowSelect in Options)
             and (UpdateLock = 0)
             and (ValidParentForm(Self).ActiveControl = Self);
  end;

  function CanDrawCheckBox: boolean;
  begin
    Result:= False;

    if IsReading then
      Exit;

    if (gdFixed in AState) and (AACol < 0) then
      Exit;

    if not Columns[AACol].Showing then
      Exit;

    if (DataLink = nil) or (not DataLink.Active) then
      Exit;

    if AARow < 0 then
      Exit;

    Result:= Columns[AACol].CheckBox.CheckBoxStyle <> ccsNone;
  end;

  function GetGlyphRect: TRect;
  var
    AARect: TRect;
  begin
    AARect:= ARect;

    with Column.Title, GlyphMargins do
    begin
      AlignRect(AARect);
      Result:= AARect;

      case GlyphAlignment of
        taRightJustify:
        begin
          Dec(Result.Right, Right);
          Result.Left:= Result.Right - Glyph.Width;
        end;

        taLeftJustify:
        begin
          Inc(Result.Left, Left);
          Result.Right:= Result.Left + Glyph.Width;
        end;

        else //taCenter
        begin
          Result.Left:= Result.Left +
                        ((Result.Right - Result.Left - Glyph.Width) div 2);
          Result.Right:= Result.Left + Glyph.Width;
        end;
      end;

      Inc(Result.Top, Top);
      Result.Bottom:= Result.Top + Glyph.Height;
      AlignRects(AARect, Result);//Recta con las margenes correctas
    end;
  end;

  function GetFieldText: string;
  var
    OldActive: integer;
  begin
    Result:= '';

    if Assigned(DataLink) and DataLink.Active then
      if Assigned(Columns[AACol].Field) then
      begin
        OldActive:= DataLink.ActiveRecord;

        try
          DataLink.ActiveRecord:= AARow;
          Result:= Column.Field.DisplayText;
        finally
          DataLink.ActiveRecord:= OldActive;
        end;
      end;
  end;

  procedure DrawBackgroundCell;
  begin
    if HasBackground then
      DrawBackground(ARect, AState)
    else
      Canvas.FillRect(ARect);
  end;

  procedure WriteText(const AText: string; Alignment: TAlignment;
                  EllipseStyle: THDSEllipseStyle; ShowAccellerator: boolean);
  var
    TextRect: TRect;
    Flags: integer;
    OldStyle: TBrushStyle;

  const
    TEXT_FLAGS = DT_VCENTER or  DT_SINGLELINE;
  begin
    TextRect:= ARect;
    Inc(TextRect.Left, 3);
    Dec(TextRect.Right, 3);
    OldStyle:= Canvas.Brush.Style;
    Canvas.Brush.Style:= bsClear;

    case Alignment of
      taLeftJustify: Flags:= DT_LEFT;
      taRightJustify: Flags:= DT_RIGHT;
      else //taCenter
        Flags:= DT_CENTER;
    end;

    case EllipseStyle of
      ellEnd: Flags:= Flags or DT_END_ELLIPSIS;
      ellPath: Flags:= Flags or DT_PATH_ELLIPSIS;
    end;

    if not ShowAccellerator then
      Flags:= Flags or DT_NOPREFIX;

    Flags:= Flags or TEXT_FLAGS;
    Flags:= DrawTextBiDiModeFlags(Flags);
    DrawTextEx(Canvas.Handle, PChar(AText), -1, TextRect, Flags, nil);
    Canvas.Brush.Style:= OldStyle;
  end;

  procedure DoFixedState;
  begin
    InflateRect(ARect, 1, 1);
    DrawEdge(Canvas.Handle, ARect, BDR_RAISEDINNER, BF_BOTTOMRIGHT);
    DrawEdge(Canvas.Handle, ARect, BDR_RAISEDINNER, BF_TOPLEFT);
  end;

begin
  AACol:= RawToDataColumn(ACol);
  AARow:= ARow - FixedRows; //Titulo
  Column:= nil;

  if (AACol >= 0) and (Columns.Count > AACol) then
    Column:= Columns[AACol];

  if (Column <> nil) and not IsReading then
  begin
    FixedState:= (gdFixed in AState) and
          ([dgRowLines, dgColLines] * Options = [dgRowLines, dgColLines]);
    HasBackground:= ((FBackgroundStyle = bgsAll) or
                    (FBackgroundStyle = bgsCells)) and
                    CanDrawBackground;

    if (AARow < 0) and (AACol >= 0) then //Titulo
    begin
      with Column.Title do
      begin
        Canvas.Brush.Color:= Color;
        Canvas.FillRect(ARect);
        Frame3D(Canvas, ARect, clBtnHighlight, clBtnShadow, 1);

        if Assigned(Glyph) then
        begin
          if Column.Transparent then
            Canvas.BrushCopy(GetGlyphRect, Glyph,  Rect(0, 0, Glyph.Width,
                             Glyph.Height), Glyph.Canvas.Pixels[0, 0])
          else
            Canvas.BrushCopy(GetGlyphRect, Glyph,  Rect(0, 0, Glyph.Width,
                             Glyph.Height), Canvas.Brush.Color);
        end;

        Canvas.Font.Assign(Font);
        WriteText(Caption, Alignment, EllipseStyle,
                   coUseAccellerator in Column.Options);
      end;
    end
    else if CanDrawCheckBox then
    begin
      if Assigned(Column.Field) then
      begin
        if HighlightCell(ACol, ARow, '', AState) then
          Canvas.Brush.Color := clHighlight
        else
          Canvas.Brush.Color:= Column.Color; //Background para el Glyph

        if FixedState then
          InflateRect(ARect, -1, -1);

        DrawBackgroundCell;
        Value:= GetFieldText;

        if Value = Column.CheckBox.CheckedValue then
          DrawCheckBox(ARect, cbChecked, Column)
        else if Value = Column.CheckBox.UnCheckedValue then
          DrawCheckBox(ARect, cbUnChecked, Column)
        else
          DrawCheckBox(ARect, cbGrayed, Column);
      end
      else
        DrawCheckBox(ARect, cbGrayed, Column);

      if FixedState then
        DoFixedState;

      if CanDrawFocus then
        Windows.DrawFocusRect(Handle, ARect);

      if Columns.State = csDefault then
        DrawDataCell(ARect, Column.Field, AState);

      DrawColumnCell(ARect, AACol, Column, AState);
    end
    else if (AACol >= 0) then
    begin
      if FixedState then
        InflateRect(ARect, -1, -1);

      if not HasBackground then
      begin
        if HighlightCell(ACol, ARow, '', AState) then
          Canvas.Brush.Color:= clHighlight
        else
          Canvas.Brush.Color:= Column.Color;
      end;

      DrawBackgroundCell;
      Canvas.Font.Assign(Column.Font);

      if gdSelected in AState then
        if gdFocused in AState then
          Canvas.Font.Color:= Column.SelectedColor
        else
          Canvas.Font.Color:= Column.FocusedColor;

      WriteText(GetFieldText, Column.Alignment, Column.EllipseStyle, False);

      if FixedState then
        DoFixedState;

      if Columns.State = csDefault then
        DrawDataCell(ARect, Column.Field, AState);

      DrawColumnCell(ARect, AACol, Column, AState);
    end
    else
      inherited DrawCell(ACol, ARow, ARect, AState);
  end
  else
    inherited DrawCell(ACol, ARow, ARect, AState);
end;

procedure THDSDBGrid.DrawCheckBox(ARect: TRect; AState: TCheckBoxState;
                                  Column: THDSColumn);
var
  DrawState: Integer;
  AARect, DrawCheckRect, DrawGlyphRect: TRect;
  Bitmap: TBitmap;
begin
  if coCheckBox in Column.Options then
  begin
    with GetCheckBoxRect(ARect) do
    begin
      DrawCheckRect.Left:= Left + (Right - Left - FCheckBoxWidth) div 2;
      DrawCheckRect.Top:= Top + (Bottom - Top - FCheckBoxWidth) div 2;
      DrawCheckRect.Right:= DrawCheckRect.Left + FCheckBoxWidth;
      DrawCheckRect.Bottom:= DrawCheckRect.Top + FCheckBoxHeight;
    end;

    AlignRects(ARect, DrawCheckRect);

    case AState of
      cbChecked: DrawState:= DFCS_BUTTONCHECK  or DFCS_CHECKED;
      cbUnChecked: DrawState:= DFCS_BUTTONCHECK;
      else //cbGrayed:
        DrawState:= DFCS_BUTTON3STATE or DFCS_CHECKED;
    end;

    DrawFrameControl(Canvas.Handle, DrawCheckRect, DFC_BUTTON, DrawState);
  end;

  if coCheckBoxGlyph in Column.Options then
  begin
    Bitmap:= nil;

    case AState of
      cbChecked:
        if Assigned(Column.CheckBox.CheckedGlyph) then
          Bitmap:= Column.CheckBox.CheckedGlyph;

      cbUnChecked:
        if Assigned(Column.CheckBox.UnCheckedGlyph) then
          Bitmap:= Column.CheckBox.UnCheckedGlyph;

      else
        if Assigned(Column.CheckBox.GrayedGlyph) then
          Bitmap:= Column.CheckBox.GrayedGlyph;
    end;

    if (Bitmap <> nil) and (not Bitmap.Empty)  then
    begin
      with Column.CheckBox.GlyphMargins do
      begin
        AARect:= ARect;

        if coCheckBox in Column.Options then
          AARect.Left:= DrawCheckRect.Right;

        AlignRect(AARect);
      end;

      DrawGlyphRect:= AARect;

      with DrawGlyphRect do
        case Column.CheckBox.GlyphAlignment of
          taLeftJustify: Right:= Left + Bitmap.Width;
          taRightJustify: Left:= Right - Bitmap.Width;
          else //taCenter;
          begin
            Left:= Left + ((Right - Left - Bitmap.Width) div 2);
            Right:= Left + Bitmap.Width;
          end;
        end;

      AlignRects(AARect, DrawGlyphRect);

      with DrawGlyphRect do
        if Column.Transparent then
          Canvas.BrushCopy(DrawGlyphRect, Bitmap, Rect(0, 0, Right - Left,
                           Bottom - Top), Bitmap.Canvas.Pixels[0, 0])
        else
          Canvas.BrushCopy(DrawGlyphRect, Bitmap, Rect(0, 0, Right - Left,
                           Bottom - Top), Canvas.Brush.Color);

    end;
  end;
end;

procedure THDSDBGrid.Paint;
var
   i, EndX, EndY: integer;
begin
  inherited Paint;

  if (FBackgroundStyle = bgsAll) or (FBackgroundStyle = bgsBack) then
    if CanDrawBackground then
    begin
       EndX:= 0;
       for i:= 0 to FixedCols-1 do
         Inc(EndX, (ColWidths[i] + 1));

       for i := LeftCol to ColCount - 1 do
         Inc(EndX, (ColWidths[i] + 1));

       EndY:= 0;

       for i:= 0 to FixedRows - 1 do
         Inc(EndY, (Rowheights[i] + 1));

       for i:= TopRow to Rowcount - 1 do
         Inc(EndY, (Rowheights[i] + 1));

       if EndX < ClientWidth  then
         DrawBackground(Rect(EndX + 1, 0, ClientWidth, EndY), []);

       if EndY < ClientHeight then
         DrawBackground(Rect(0, EndY, ClientWidth, ClientHeight), []);
    end;
end;

procedure THDSDBGrid.PaintTab(Highlight: boolean);
const
  TEXT_FLAGS = DT_VCENTER or  DT_SINGLELINE or DT_END_ELLIPSIS;
var
  ATabRect: TRect;
  Flags: integer;
  TabCanvas: TCanvas;
  ABitmap: TBitmap;
begin
  if FTabGrid.Visible then
  begin
    GetWindowRect(Handle, ATabRect);
    ATabRect.Bottom:= ATabRect.Top + FTabGrid.Size + 2;
    OffsetRect(ATabRect, -ATabRect.Left, -ATabRect.Top);
    TabCanvas:= TCanvas.Create;
    ABitmap:= TBitmap.Create;

    with ATabRect do
    begin
      ABitmap.Width:= Right - Left;
      ABitmap.Height:= Bottom - Top;
    end;

    with ABitmap do
    begin
      Canvas.Brush.Style:= bsSolid;
      Canvas.Brush.Color:= FTabGrid.Color;
      Canvas.FillRect(Rect(0, 0, Width, Height));
    end;

    case FTabGrid.FillStyle of
      tfGradient: FTabGrid.Gradient.DrawGradient(ABitmap, Highlight);
      tfTexture: FTabGrid.Texture.DrawTexture(ABitmap, Highlight);
    end;

    with TabCanvas do
      try
        Handle:= GetWindowDC(Self.Handle);
        Draw(0, 0, ABitmap);

        if Highlight then
          Font.Assign(FTabGrid.HighlightFont)
        else
          Font.Assign(FTabGrid.Font);

        case FTabGrid.Style of
          tgRaised: Frame3D(TabCanvas, ATabRect, clBtnHighlight, clBtnShadow,
                            FTabGrid.BorderWidth);
          tgLowered: Frame3D(TabCanvas, ATabRect, clBtnShadow, clBtnHighlight,
                             FTabGrid.BorderWidth);
        end;

        case FTabGrid.Alignment of
          taLeftJustify: Flags:= TEXT_FLAGS or DT_LEFT;
          taRightJustify: Flags:= TEXT_FLAGS or DT_RIGHT;
          else
            Flags:= TEXT_FLAGS or DT_CENTER;
        end;

        if FTabGrid.FillStyle = tfTexture then
        begin
          Brush.Style:= bsSolid;

          if Highlight then
            Brush.Color:= FTabGrid.Texture.HighlightColor
          else
            Brush.Color:= FTabGrid.Texture.Color;
        end
        else
          Brush.Style:= bsClear;
            
        Flags:= DrawTextBiDiModeFlags(Flags);
        DrawTextEx(Handle, PChar(FTabGrid.Title), -1, ATabRect, Flags, nil);
      finally
        ReleaseDC(Self.Handle, TabCanvas.Handle);
        Handle:= 0;
        ABitmap.Free;
        Free;
      end;
  end;
end;

procedure THDSDBGrid.HideEditor;
begin
  inherited HideEditor;
end;

procedure THDSDBGrid.InvalideTab;
begin
  SetWindowPos(Handle, 0, 0, 0, 0, 0, SWP_FRAMECHANGED or SWP_NOACTIVATE or
               SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER);
end;

function THDSDBGrid.TabHitTest(X, Y: integer): boolean;
begin
  Result:= PtInRect(GetTabRect, Point(X, Y));
end;

function THDSDBGrid.IsReading: boolean;
begin
  Result:= ComponentState * [csLoading, csReading, csUpdating] <> [];
end;

procedure THDSDBGrid.NewMaxDataHeight(NewHeight: integer);
begin
  DataRowsHeight:= NewHeight;
end;

procedure THDSDBGrid.NewMaxTitleHeight(NewHeight: integer);
begin
  TitleHeight:= NewHeight;
end;

procedure THDSDBGrid.RowHeightsChanged;
begin
  if not IsReading then
    if not FAutoSize then
    begin
      if DefaultRowHeight <> FDataRowsHeight then
        DefaultRowHeight:= FDataRowsHeight;

      if RowHeights[0] <> FTitleHeight then
        RowHeights[0]:= FTitleHeight;
    end
    else
    begin
      FDataRowsHeight:= DefaultRowHeight;
      FTitleHeight:= RowHeights[0];
    end;
end;

//Manejo de eventos
procedure THDSDBGrid.ButtonClick(Column: THDSColumn);
begin
  if Assigned(FOnButtonClick) then
    FOnButtonClick(Column);
end;

procedure THDSDBGrid.CalendarDblClick(Column: THDSColumn);
begin
  if Assigned(FOnCalendarDblClick) then
    FOnCalendarDblClick(Column);
end;

procedure THDSDBGrid.CheckBoxClick(Column: THDSColumn);
begin
  if Assigned(FOnCheckBoxClick) then
    FOnCheckBoxClick(Column);
end;

procedure THDSDBGrid.GraphicDblClick(Column: THDSColumn);
begin
  if Assigned(FOnGraphicDblClick) then
    FOnGraphicDblClick(Column);
end;

procedure THDSDBGrid.GraphicOpenClick(Column: THDSColumn; DBImage: TDBImage);
begin
  if Assigned(FOnGraphicOpenClick) then
    FOnGraphicOpenClick(Column, DBImage);
end;

procedure THDSDBGrid.GraphicSaveClick(Column: THDSColumn; DBImage: TDBImage);
begin
  if Assigned(FOnGraphicSaveClick) then
    FOnGraphicSaveClick(Column, DBImage);
end;

procedure THDSDBGrid.MemoDblClick(Column: THDSColumn);
begin
  if Assigned(FOnMemoDblClick) then
    FOnMemoDblClick(Column);
end;

procedure THDSDBGrid.MemoOpenClick(Column: THDSColumn; DBMemo: TDBMemo);
begin
  if Assigned(FOnMemoOpenClick) then
    FOnMemoOpenClick(Column, DBMemo);
end;

procedure THDSDBGrid.MemoSaveClick(Column: THDSColumn; DBMemo: TDBMemo);
begin
  if Assigned(FOnMemoSaveClick) then
    FOnMemoSaveClick(Column, DBMemo);
end;

//Manejo del CheckBox
procedure THDSDBGrid.GetCheckBoxSize;
begin
  with TBitmap.Create do
    try
      Handle:= LoadBitmap(0, PChar(32759));
      FCheckBoxWidth:= Width div 4;
      FCheckBoxHeight:= Height div 3;
    finally
      Free;
    end;
end;

function THDSDBGrid.GetCheckBoxRect(ARect: TRect): TRect;
begin
  Result:= ARect;
  Result.Right:= ARect.Left + FCheckBoxWidth + 4;

  if Result.Right > ARect.Right then
    Result.Right:= ARect.Right;
end;

function THDSDBGrid.GetTabRect: TRect;
begin
  GetWindowRect(Handle, Result);
  Result.Bottom:= Result.Top + FTabGrid.Size;
end;

//Manejo del teclado
function THDSDBGrid.FindAccellerator(CharCode: word): boolean;
var
  i: integer;
begin
  Result:= (not Focused) and IsAccellerator(CharCode, FTabGrid.Title);

  if Result then
    SetFocus
  else if Focused then
    for i:= 0 to Columns.Count - 1 do
      with Columns[i] do
        if (coUseAccellerator in Options) and
           IsAccellerator(CharCode, Title.Caption) then
        begin
          Result:= True;
          Col:= DataToRawColumn(i);
          Break;
        end;
end;

procedure THDSDBGrid.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
end;

//Implementacin de THDSortSDBGrid
//THDSColumnSort
constructor THDSColumnSort.Create(Column: THDSColumn);
begin
  inherited Create;
  FColumn:= Column;
  FSortStyle:= cssNone;
  FSortAscGlyph:= TBitmap.Create;
  FSortDesGlyph:= TBitmap.Create;
  FSortNoneGlyph:= TBitmap.Create;
end;

destructor THDSColumnSort.Destroy;
begin
  FSortAscGlyph.Free;
  FSortAscGlyph:= nil;
  FSortDesGlyph.Free;
  FSortDesGlyph:= nil;
  FSortNoneGlyph.Free;
  FSortNoneGlyph:= nil;
  inherited Destroy;
end;

procedure THDSColumnSort.Assign(Source: TPersistent);
begin
  if Source is THDSColumnSort then
    with THDSColumnSort(Source) do
    begin
      Self.FSortStyle:= FSortStyle;
      Self.FSortAscGlyph.Assign(FSortAscGlyph);
      Self.FSortDesGlyph.Assign(FSortDesGlyph);
      Self.FSortNoneGlyph.Assign(FSortNoneGlyph);
    end
  else
    inherited Assign(Source);
end;

procedure THDSColumnSort.SetSortAscGlyph(const Value: TBitmap);
begin
  if Assigned(FSortAscGlyph) then
  begin
    FSortAscGlyph.Assign(Value);

    with FColumn do
    begin
      if FSortStyle = cssAscendent then
        Title.Glyph:= FSortAscGlyph;

      Collection.UpdateGlyph(Index, FSortAscGlyph, Title.GlyphMargins);
    end;
  end;
end;

procedure THDSColumnSort.SetSortDesGlyph(const Value: TBitmap);
begin
  if Assigned(FSortDesGlyph) then
  begin
    FSortDesGlyph.Assign(Value);

    with FColumn do
    begin
      if FSortStyle = cssDescendent then
        Title.Glyph:= FSortDesGlyph;

      Collection.UpdateGlyph(Index, FSortDesGlyph, Title.GlyphMargins);
    end;
  end;
end;

procedure THDSColumnSort.SetSortNoneGlyph(const Value: TBitmap);
begin
  if Assigned(FSortNoneGlyph) then
  begin
    FSortNoneGlyph.Assign(Value);

    with FColumn do
    begin
      if FSortStyle = cssNone then
        Title.Glyph:= FSortNoneGlyph;

      Collection.UpdateGlyph(Index, FSortNoneGlyph, Title.GlyphMargins);
    end;
  end;
end;

procedure THDSColumnSort.SetSortStyle(const Value: THDSSortStyle);
begin
  if FSortStyle <> Value then
  begin
    FSortStyle:= Value;

    case FSortStyle of
      cssAscendent: FColumn.Title.Glyph:= FSortAscGlyph;
      cssDescendent: FColumn.Title.Glyph:= FSortDesGlyph;
      else //cssNone
        FColumn.Title.Glyph:= FSortNoneGlyph;
    end;
  end;
end;

function THDSColumnSort.GetCollection: THDSColumns;
begin
  Result:= FColumn.Collection;
end;

//THDSSortColumn
constructor THDSSortColumn.Create(AOwner: TCollection);
begin
  inherited Create(AOwner);
  FSort:= CreateSort;
  FSortable:= False;
end;

destructor THDSSortColumn.Destroy;
begin
  FSort.Free;
  FSort:= nil;
  inherited Destroy;
end;

procedure THDSSortColumn.Assign(Source: TPersistent);
begin
  if Source is THDSSortColumn then
    with THDSSortColumn(Source) do
      Self.FSort.Assign(FSort);

  inherited Assign(Source);
end;

function THDSSortColumn.CreateSort: THDSColumnSort;
begin
  Result:= THDSColumnSort.Create(Self);
end;

//THDSSortColumns
function THDSSortColumns.GetItem(Index: integer): THDSSortColumn;
begin
  Result:= THDSSortColumn(inherited GetItem(Index));
end;

procedure THDSSortColumns.SetItem(Index: integer; NewItem: THDSSortColumn);
begin
  inherited SetItem(Index, NewItem);
end;

function THDSSortColumns.Add: THDSSortColumn;
begin
  Result:= THDSSortColumn(inherited Add);
end;

//THDSSortDBGrid
function THDSSortDBGrid.GetColumns: THDSSortColumns;
begin
  Result:= THDSSortColumns(inherited Columns);
end;

procedure THDSSortDBGrid.SetColumns(Value: THDSSortColumns);
begin
  inherited Columns:= Value;
end;

constructor THDSSortDBGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FLastColumn:= nil;
end;

function THDSSortDBGrid.GetSQLOrder(Column: THDSSortColumn): string;
  function ExtractTableName(const AOrigin: string): string;
  begin
    if (AOrigin <> '') and (AOrigin[1] = '"') then
      Result:= Copy(AOrigin, 2, Pos('.', AOrigin) - 2)
    else if (AOrigin <> '') then
      Result:= Copy(AOrigin, 1, Pos('.', AOrigin) - 1);
  end;

begin
 Result:= '';

  with Column do
    if Sort.SortStyle <> cssNone then
    begin
      if Field.DataSet is TTable then
        Result:= Result + ExtractTableName(TTable(Field.DataSet).TableName)
                        + '."' + Field.FullName + '"'
      else
        Result:= ExtractTableName(Field.Origin) + '."' + Field.FullName + '"';

      if Sort.SortStyle = cssDescendent then
        Result:= Result + ' DESC ';
    end;
end;

function THDSSortDBGrid.CreateColumns: TDBGridColumns;
begin
  Result:= THDSSortColumns.Create(Self, THDSSortColumn);
end;

procedure THDSSortDBGrid.TitleClick(Column: TColumn);
begin
  with THDSSortColumn(Column), Sort do
  begin
    if Sortable then
    begin
      if SortStyle = cssAscendent then
        SortStyle:= cssDescendent
      else
        SortStyle:= cssAscendent;
    end;

    if (FLastColumn <> nil) and (FLastColumn <> Column) then
      FLastColumn.Sort.SortStyle:= cssNone;

    FLastColumn:= THDSSortColumn(Column);
  end;

  inherited TitleClick(Column);
  SortOrderChanged(THDSSortColumn(Column));
end;

procedure THDSSortDBGrid.SortOrderChanged(Column: THDSSortColumn);
begin
  if Column.Sortable and Assigned(Column.Field) and Assigned(FOnSort) then
    FOnSort(Column);
end;

procedure Register;
begin
  RegisterComponents('Hades', [THDSDBGrid, THDSSortDBGrid]);
end;

end.

